type Nullable<T> = T | null | undefined
export declare interface KtList<E> /* extends Collection<E> */ {
    asJsReadonlyArrayView(): ReadonlyArray<E>;
    readonly __doNotUseOrImplementIt: {
        readonly "kotlin.collections.KtList": unique symbol;
    };
}
export declare const KtList: {
    getInstance(): {
        fromJsArray<E>(array: ReadonlyArray<E>): KtList<E>;
    };
};
export declare interface KtSet<E> /* extends Collection<E> */ {
    asJsReadonlySetView(): ReadonlySet<E>;
    readonly __doNotUseOrImplementIt: {
        readonly "kotlin.collections.KtSet": unique symbol;
    };
}
export declare const KtSet: {
    getInstance(): {
        fromJsSet<E>(set: ReadonlySet<E>): KtSet<E>;
    };
};
export declare interface BigDecimal /* extends Comparable<BigDecimal> */ {
    readonly absoluteValue: BigDecimal;
    readonly signum: number;
    readonly scale: number;
    readonly precision: number;
    readonly unscaledValue: BigInteger;
    plus(augend: Nullable<BigDecimal>): BigDecimal;
    plusWithContext(augend: Nullable<BigDecimal>, mc: MathContext): BigDecimal;
    minus(subtrahend: BigDecimal): BigDecimal;
    minusWithContext(subtrahend: BigDecimal, mc: MathContext): BigDecimal;
    times(multiplicand: Nullable<BigDecimal>): BigDecimal;
    timesWithContext(multiplicand: BigDecimal, mc: MathContext): BigDecimal;
    div(divisor: BigDecimal): BigDecimal;
    divWithContext(divisor: BigDecimal, mc: MathContext): Nullable<BigDecimal>;
    divideToIntegralValue(divisor: BigDecimal): BigDecimal;
    divideToIntegralValueWithContext(divisor: BigDecimal, mc: MathContext): BigDecimal;
    rem(divisor: BigDecimal): BigDecimal;
    remWithContext(divisor: BigDecimal, mc: MathContext): BigDecimal;
    divideAndRemainder(divisor: BigDecimal): any/* Pair<BigDecimal, BigDecimal> */;
    divideAndRemainderWithContext(divisor: BigDecimal, mc: MathContext): any/* Pair<BigDecimal, BigDecimal> */;
    sqrt(mc?: MathContext): BigDecimal;
    pow(n: number): BigDecimal;
    powWithContext(n: number, mc: MathContext): Nullable<BigDecimal>;
    absoluteValueWithContext(mc: MathContext): Nullable<BigDecimal>;
    unaryMinus(): BigDecimal;
    unaryMinusWithContext(mc: MathContext): Nullable<BigDecimal>;
    unaryPlus(): BigDecimal;
    unaryPlusWithContext(mc: MathContext): Nullable<BigDecimal>;
    round(mc: MathContext): Nullable<BigDecimal>;
    setScaleRounding(newScale: number, roundingMode: RoundingMode): BigDecimal;
    /** @deprecated The method {@link #setScale(int, RoundingMode)} should be used in preference to this legacy method. */
    setScaleInt(newScale: number, roundingMode: number): BigDecimal;
    setScale(newScale: number): BigDecimal;
    movePointLeft(n: number): BigDecimal;
    movePointRight(n: number): BigDecimal;
    scaleByPowerOfTen(n: number): BigDecimal;
    stripTrailingZeros(): BigDecimal;
    min(val: BigDecimal): BigDecimal;
    max(val: BigDecimal): BigDecimal;
    toEngineeringString(): string;
    toPlainString(): string;
    toBigInteger(): BigInteger;
    toBigIntegerExact(): BigInteger;
    toLong(): any/* Long */;
    toLongExact(): any/* Long */;
    toInt(): number;
    toByte(): number;
    toChar(): any/* Char */;
    toShort(): number;
    toIntExact(): number;
    toShortExact(): number;
    toByteExact(): number;
    toFloat(): number;
    toDouble(): number;
    ulp(): BigDecimal;
    readonly __doNotUseOrImplementIt: {
        readonly "com.macrofocus.common.math.big.BigDecimal": unique symbol;
    };
}
export declare const BigDecimal: {
    getInstance(): {
        get ZERO(): BigDecimal;
        get ONE(): BigDecimal;
        get TWO(): BigDecimal;
        get TEN(): BigDecimal;
        get ONE_TENTH(): BigDecimal;
        get ONE_HALF(): BigDecimal;
        get PI(): BigDecimal;
        get E(): BigDecimal;
        ofScaledLong(unscaledVal: any/* Long */, scale: number): BigDecimal;
        ofScaledLongWithPrecision(unscaledVal: any/* Long */, scale: number, prec: number): BigDecimal;
        ofInt(val: number): BigDecimal;
        of(val: any/* Long */): BigDecimal;
        ofScaledBigIntegerWithPrecision(intVal: BigInteger, scale: number, prec: number): BigDecimal;
        ofDouble(val: number, ctx?: Nullable<MathContext>): BigDecimal;
        ofFloat(val: number, ctx?: Nullable<MathContext>): BigDecimal;
        parse(val: string, ctx?: Nullable<MathContext>): BigDecimal;
        ofBigInteger(val: BigInteger, ctx?: Nullable<MathContext>): BigDecimal;
        ofIntWithContext(val: number, ctx: MathContext): BigDecimal;
        ofWithContext(val: any/* Long */, ctx: MathContext): BigDecimal;
    };
};
export declare interface BigInteger /* extends Comparable<BigInteger> */ {
    readonly absoluteValue: BigInteger;
    readonly signum: number;
    readonly bitLength: number;
    readonly bitCount: number;
    rangeTo(endInclusive: BigInteger): BigIntegerRange;
    rangeToInt(endInclusive: number): BigIntegerRange;
    rangeToLong(endInclusive: any/* Long */): BigIntegerRange;
    nextProbablePrime(): BigInteger;
    plus(other: BigInteger): BigInteger;
    plusInt(other: number): BigInteger;
    plusLong(other: any/* Long */): BigInteger;
    minus(other: BigInteger): BigInteger;
    minusInt(other: number): BigInteger;
    minusLong(other: any/* Long */): BigInteger;
    times(other: BigInteger): BigInteger;
    timesInt(other: number): BigInteger;
    timesLong(other: any/* Long */): BigInteger;
    div(other: BigInteger): BigInteger;
    divInt(other: number): BigInteger;
    divLong(other: any/* Long */): BigInteger;
    divideAndRemainder(other: BigInteger): Array<BigInteger>;
    divideAndRemainderInt(other: number): Array<BigInteger>;
    divideAndRemainderLong(other: any/* Long */): Array<BigInteger>;
    reminder(other: BigInteger): BigInteger;
    reminderInt(other: number): BigInteger;
    reminderLong(other: any/* Long */): BigInteger;
    pow(exponent: number): BigInteger;
    sqrt(): BigInteger;
    sqrtAndRemainder(): Array<BigInteger>;
    gcd(other: BigInteger): BigInteger;
    gcdInt(other: number): BigInteger;
    gcdLong(other: any/* Long */): BigInteger;
    unaryMinus(): BigInteger;
    unaryPlus(): BigInteger;
    rem(modulus: BigInteger): BigInteger;
    remInt(modulus: number): BigInteger;
    remLong(modulus: any/* Long */): BigInteger;
    modPow(exponent: BigInteger, modulus: BigInteger): BigInteger;
    modInverse(modulus: BigInteger): BigInteger;
    modInverseInt(modulus: number): BigInteger;
    modInverseLong(modulus: any/* Long */): BigInteger;
    shl(n: number): BigInteger;
    shr(n: number): BigInteger;
    and(other: BigInteger): BigInteger;
    andInt(other: number): BigInteger;
    andLong(other: any/* Long */): BigInteger;
    or(other: BigInteger): BigInteger;
    orInt(other: number): BigInteger;
    orLong(other: any/* Long */): BigInteger;
    xor(other: BigInteger): BigInteger;
    xorInt(other: number): BigInteger;
    xorLong(other: any/* Long */): BigInteger;
    not(): BigInteger;
    andNot(other: BigInteger): BigInteger;
    andNotInt(other: number): BigInteger;
    andNotLong(other: any/* Long */): BigInteger;
    testBit(n: number): boolean;
    get(n: number): boolean;
    set(n: number, b: boolean): BigInteger;
    setBit(n: number): BigInteger;
    clearBit(n: number): BigInteger;
    flipBit(n: number): BigInteger;
    isProbablePrime(certainty: number): boolean;
    equals(other: Nullable<any>): boolean;
    min(other: BigInteger): BigInteger;
    max(other: BigInteger): BigInteger;
    hashCode(): number;
    toStringWithRadix(radix: number): string;
    toString(): string;
    toByteArray(): Int8Array;
    toInt(): number;
    toLong(): any/* Long */;
    toByte(): number;
    toChar(): any/* Char */;
    toShort(): number;
    toFloat(): number;
    toDouble(): number;
    toLongExact(): any/* Long */;
    toIntExact(): number;
    toShortExact(): number;
    toByteExact(): number;
    readonly __doNotUseOrImplementIt: {
        readonly "com.macrofocus.common.math.big.BigInteger": unique symbol;
    };
}
export declare const BigInteger: {
    getInstance(): {
        get ZERO(): BigInteger;
        get ONE(): BigInteger;
        get TWO(): BigInteger;
        get NEGATIVE_ONE(): BigInteger;
        get TEN(): BigInteger;
        probablePrime(bitLength: number, rnd: any/* Random */): BigInteger;
        ofLong(value: any/* Long */): BigInteger;
        of(value: number): BigInteger;
        parse(value: string): BigInteger;
        parseWithRadix(value: string, radix: number): BigInteger;
        ofIntArray(value: Int32Array): BigInteger;
        ofSlideIntArray(signum: number, magnitude: Int8Array, off: number, len: number): BigInteger;
    };
};
export declare class BigIntegerRange /* implements ClosedRange<BigInteger>, Iterable<BigInteger> */ {
    constructor(start: BigInteger, endInclusive: BigInteger);
    copy(start?: BigInteger, endInclusive?: BigInteger): BigIntegerRange;
    toString(): string;
    hashCode(): number;
    equals(other: Nullable<any>): boolean;
}
export declare class MathContext {
    constructor(precision?: number, roundingMode?: RoundingMode);
    get precision(): number;
    get roundingMode(): RoundingMode;
    copy(precision?: number, roundingMode?: RoundingMode): MathContext;
    toString(): string;
    hashCode(): number;
    equals(other: Nullable<any>): boolean;
    static get Companion(): {
        get UNLIMITED(): MathContext;
        get DECIMAL32(): MathContext;
        get DECIMAL64(): MathContext;
        get DECIMAL128(): MathContext;
    };
}
export declare abstract class RoundingMode {
    private constructor();
    static get UP(): RoundingMode & {
        get name(): "UP";
        get ordinal(): 0;
    };
    static get DOWN(): RoundingMode & {
        get name(): "DOWN";
        get ordinal(): 1;
    };
    static get CEILING(): RoundingMode & {
        get name(): "CEILING";
        get ordinal(): 2;
    };
    static get FLOOR(): RoundingMode & {
        get name(): "FLOOR";
        get ordinal(): 3;
    };
    static get HALF_UP(): RoundingMode & {
        get name(): "HALF_UP";
        get ordinal(): 4;
    };
    static get HALF_DOWN(): RoundingMode & {
        get name(): "HALF_DOWN";
        get ordinal(): 5;
    };
    static get HALF_EVEN(): RoundingMode & {
        get name(): "HALF_EVEN";
        get ordinal(): 6;
    };
    static get UNNECESSARY(): RoundingMode & {
        get name(): "UNNECESSARY";
        get ordinal(): 7;
    };
    get name(): "UP" | "DOWN" | "CEILING" | "FLOOR" | "HALF_UP" | "HALF_DOWN" | "HALF_EVEN" | "UNNECESSARY";
    get ordinal(): 0 | 1 | 2 | 3 | 4 | 5 | 6 | 7;
    get value(): number;
    static values(): Array<RoundingMode>;
    static valueOf(value: string): RoundingMode;
    static get Companion(): {
        valueOfInt(rm: number): RoundingMode;
    };
}
export declare class PropertyEvent<T> {
    constructor(oldValue: T, newValue: T);
    get oldValue(): T;
    get newValue(): T;
    toString(): string;
    copy(oldValue?: T, newValue?: T): PropertyEvent<T>;
    hashCode(): number;
    equals(other: Nullable<any>): boolean;
}
export declare class SimpleProperty<T> /* extends AbstractMutableProperty<T> */ /* implements MutableProperty<T> */ {
    constructor(value: T);
    toString(): string;
    static get Companion(): {
        newInstance<T>(value: T): SimpleProperty<T>;
    };
}
export declare class JsArrayList<E> /* extends ArrayList<E> */ implements KtList<E> {
    constructor(elements: Array<E>);
    asJsReadonlyArrayView(): ReadonlyArray<E>;
    readonly __doNotUseOrImplementIt: KtList<E>["__doNotUseOrImplementIt"];
}
export declare function bigInteger(x: any): BigInteger;
export declare function bigDecimal(x: any): BigDecimal;
export declare class EnhancedLabel {
    constructor();
    get isOpaque(): boolean;
    set isOpaque(value: boolean);
    get properties(): any/* MutableProperties<Nullable<string>> */;
    set properties(value: any/* MutableProperties<Nullable<string>> */);
    static fromString(text: Nullable<string>): EnhancedLabel;
    setName(name: Nullable<string>): void;
    getName(): Nullable<string>;
    getText(): Nullable<string>;
    setText(text: Nullable<string>): void;
    get isHTML(): boolean;
    set isHTML(value: boolean);
    getFont(): Nullable<any>/* Nullable<CPFont> */;
    setFont(font: any/* CPFont */): void;
    getVerticalAlignment(): number;
    setVerticalAlignment(verticalAlignment: number): void;
    getHorizontalAlignment(): number;
    setHorizontalAlignment(horizontalAlignment: number): void;
    getHeight(): Nullable<number>;
    getWidth(): Nullable<number>;
    getBackground(): Nullable<any>/* Nullable<CPColor> */;
    setBackground(background: Nullable<any>/* Nullable<CPColor> */): void;
    getForeground(): Nullable<any>/* Nullable<CPColor> */;
    setForeground(foreground: any/* CPColor */): void;
    isEnabled(): boolean;
    getInsetTop(): number;
    getInsetLeft(): number;
    getInsetBottom(): number;
    getInsetRight(): number;
    setInsetTop(value: number): void;
    setInsetLeft(value: number): void;
    setInsetBottom(value: number): void;
    setInsetRight(value: number): void;
    setInsets(top: number, left: number, bottom: number, right: number): void;
    getEffect(): EnhancedLabel.Effect;
    setEffect(effect: EnhancedLabel.Effect): void;
    getEffectOpacity(): number;
    setEffectOpacity(effectOpacity: number): void;
    getRendering(): EnhancedLabel.Rendering;
    setRendering(rendering: EnhancedLabel.Rendering): void;
    getMinimumCharactersToDisplay(): Nullable<number>;
    setMinimumCharactersToDisplay(minimumCharactersToDisplay: Nullable<number>): void;
    isJustified(): boolean;
    setJustified(justified: boolean): void;
    getAngle(): number;
    setAngle(angle: number): void;
    getDesiredWidth(): number;
    setDesiredWidth(desiredSize: number): void;
    getDesiredHeight(): number;
    setDesiredHeight(desiredSize: number): void;
    static get Companion(): {
        get CENTER(): number;
        get TOP(): number;
        get LEFT(): number;
        get BOTTOM(): number;
        get RIGHT(): number;
        get HORIZONTAL(): number;
        get VERTICAL(): number;
        get LEADING(): number;
        get TRAILING(): number;
        get NEXT(): number;
    };
}
export declare namespace EnhancedLabel {
    abstract class Rendering {
        private constructor();
        static get Truncate(): EnhancedLabel.Rendering & {
            get name(): "Truncate";
            get ordinal(): 0;
        };
        static get Clip(): EnhancedLabel.Rendering & {
            get name(): "Clip";
            get ordinal(): 1;
        };
        static get WordWrap(): EnhancedLabel.Rendering & {
            get name(): "WordWrap";
            get ordinal(): 2;
        };
        get name(): "Truncate" | "Clip" | "WordWrap";
        get ordinal(): 0 | 1 | 2;
        static values(): Array<EnhancedLabel.Rendering>;
        static valueOf(value: string): EnhancedLabel.Rendering;
    }
    abstract class Effect {
        protected constructor();
        static get Plain(): {
        } & EnhancedLabel.Effect;
        static get Shadow(): {
        } & EnhancedLabel.Effect;
        static get Glow(): {
        } & EnhancedLabel.Effect;
        static get Outline(): {
        } & EnhancedLabel.Effect;
        static get Emphasize(): {
        } & EnhancedLabel.Effect;
    }
}
export declare class InterpolatedPalette /* extends FixedPalette */ {
    constructor(entries: KtSet<InterpolatedPalette.Entry>/* SortedSet<InterpolatedPalette.Entry> */);
    get entries(): KtSet<InterpolatedPalette.Entry>/* SortedSet<InterpolatedPalette.Entry> */;
    set entries(value: KtSet<InterpolatedPalette.Entry>/* SortedSet<InterpolatedPalette.Entry> */);
    static paletteConstructor(p: Palette): InterpolatedPalette;
    static entriesConstructor(e: Array<InterpolatedPalette.Entry>): InterpolatedPalette;
    getEntries(): KtSet<InterpolatedPalette.Entry>;
}
export declare namespace InterpolatedPalette {
    class Entry /* implements Comparable<InterpolatedPalette.Entry> */ {
        constructor(fraction: number, color: any/* CPColor */);
        get fraction(): number;
        getColor(): any/* CPColor */;
        equals(other: Nullable<any>): boolean;
        hashCode(): number;
    }
}
export declare class PaletteFactory {
    constructor();
    getEntries(): KtList<PaletteFactory.Entry>;
    getPalette(name: string): Palette;
    add(entry: PaletteFactory.Entry): void;
    get(name: string): Nullable<PaletteFactory.Entry>;
    find(palette: Nullable<Palette>): Nullable<PaletteFactory.Entry>;
    createDefaultDivergingPalette(): any/* FixedPalette */;
    createDefaultSequentialPalette(): any/* FixedPalette */;
    createDefaultQualititativePalette(): any/* FixedPalette */;
    createColorGradient(name: string): Nullable<any>/* Nullable<MutablePalette> */;
    static get Companion(): {
        get instance(): PaletteFactory;
    };
}
export declare namespace PaletteFactory {
    class Entry {
        constructor(name: string, type: any/* PaletteType */, colors: any/* FixedPalette */);
        get name(): string;
        get type(): any/* PaletteType */;
        getPalette(): any/* FixedPalette */;
    }
}
export declare interface FunctionalReactCanvasProps extends Props {
}
export declare function colorOf(r: number, g: number, b: number, a: number): any/* CPColor */;
export declare class DefaultDataFrame /* extends AbstractDataFrame<number, string, Nullable<any>> */ {
    constructor(dataFrame: any/* DataFrame<Nullable<any>, Nullable<any>, Nullable<any>> */);
    get series(): Array<any/* Series<number, Nullable<any>> */>;
}
export declare interface Graph<Vertex, Edge> {
    readonly nodes: any/* Iterable<Vertex> */;
    readonly links: any/* Iterable<Edge> */;
    target(link: Edge, node: Vertex): Vertex;
    getFrom(link: Edge): Vertex;
    getTo(link: Edge): Vertex;
    getLink(from: Vertex, to: Vertex): Nullable<Edge>;
    getLinks(from: Vertex): any/* Iterable<Edge> */;
    getNeighbors(from: Vertex): any/* Iterable<Vertex> */;
    readonly __doNotUseOrImplementIt: {
        readonly "org.molap.network.Graph": unique symbol;
    };
}
export declare class JsonDataFrame /* extends AbstractDataFrame<number, string, Nullable<any>> */ {
    constructor(array: Array<Nullable<any>>);
    static fromString(json: string): JsonDataFrame;
}
export declare class AlgorithmFactory {
    protected constructor(entries: Array<any/* Algorithm */>);
    add(entry: any/* Algorithm */): void;
    getDefault(): any/* Algorithm */;
    getAlgorithms(): KtList<any/* Algorithm */>;
    get(name: Nullable<string>): any/* Algorithm */;
    static get Companion(): {
        get BINARY_TREE(): any/* Algorithm */;
        get SLICE(): any/* Algorithm */;
        get SQUARIFIED(): any/* Algorithm */;
        get SQUARIFIEDPLUS(): any/* Algorithm */;
        get STRIP(): any/* Algorithm */;
        get PIVOT_BY_SPLIT_SIZE(): any/* Algorithm */;
        get SPLIT(): any/* Algorithm */;
        get CIRCULAR(): any/* Algorithm */;
        get CIRCLEPACKING(): any/* Algorithm */;
        get PIE(): any/* Algorithm */;
        get BAR(): any/* Algorithm */;
        get MATRIX(): any/* Algorithm */;
        get SUNBURST(): any/* Algorithm */;
        get ICICLE(): any/* Algorithm */;
        getInstance(): AlgorithmFactory;
    };
}
export declare class CushionRendering /* extends AbstractRendering */ implements Rendering {
    constructor();
    paintNode<N, Row, Column>(g: any/* TGraphics */, view: any/* TreeMapView<N, Row, Column> */, node: N, pass: number, bounds: any/* Rectangle */, shape: any/* Shape */): boolean;
    paintBorder<N, Row, Column>(g2: any/* TGraphics */, view: any/* TreeMapView<N, Row, Column> */, node: N, pass: number, bounds: any/* Rectangle */, shape: any/* Shape */): void;
    toString(): string;
    getPasses<N, Row, Column>(model: TreeMapModel<N, Row, Column>): number;
    getParentOrder<N, Row, Column>(view: any/* TreeMapView<N, Row, Column> */, root: N, pass: number): any/* Iterable<N> */;
    getOrder<N, Row, Column>(view: any/* TreeMapView<N, Row, Column> */, root: N, pass: number): any/* Iterable<N> */;
    paintParent<N, Row, Column>(g: any/* TGraphics */, view: any/* TreeMapView<N, Row, Column> */, node: N, pass: number, bounds: any/* Rectangle */, shape: any/* Shape */): void;
    getRenderedShape<N, Row, Column>(view: any/* TreeMapView<N, Row, Column> */, model: TreeMapModel<N, Row, Column>, node: N, shape: any/* Shape */): any/* Shape */;
    paintBackground<N, Row, Column>(g: any/* TGraphics */, view: any/* TreeMapView<N, Row, Column> */, node: N, pass: number, passes: number, bounds: any/* Rectangle */, shape: any/* Shape */): void;
    getNestingBackground<N, Row, Column>(node: N, model: TreeMapModel<N, Row, Column>): Nullable<any>/* Nullable<CPColor> */;
    paintLabel<N, Row, Column>(g: any/* TGraphics */, view: any/* TreeMapView<N, Row, Column> */, node: N, pass: number, passes: number, bounds: any/* Rectangle */, shape: any/* Shape */): void;
    paintParentBorder<N, Row, Column>(g: any/* TGraphics */, node: N, bounds: any/* Rectangle */, shape: any/* Shape */, model: TreeMapModel<N, Row, Column>): void;
    paintParentHighlight<N, Row, Column>(g2: any/* TGraphics */, view: any/* TreeMapView<N, Row, Column> */, node: N, pass: number, bounds: any/* Rectangle */, shape: Nullable<any>/* Nullable<Shape> */): void;
    readonly __doNotUseOrImplementIt: Rendering["__doNotUseOrImplementIt"];
}
export declare const DefaultAlgorithmFactory: {
    getInstance(): {
        get instance(): AlgorithmFactory;
    };
};
export declare class DefaultTreeMapColumnSettings /* extends AbstractTreeMapColumnSettings */ implements TreeMapColumnSettings {
    constructor(colorFactory: any/* MkColorFactory */, fontFactory: any/* CPFontFactory */, colorMapFactory: Nullable<any>/* Nullable<ColorMapFactory> */);
    get properties(): any/* MutableProperties<Nullable<string>> */;
    protected get algorithm(): any/* MutableSingleSelection<Nullable<Algorithm>> */;
    protected get borderThickness(): any/* MutableBoundedInterval */;
    get labelingEffect(): any/* MutableProperty<Nullable<EnhancedLabel.Effect>> */;
    set labelingEffect(value: any/* MutableProperty<Nullable<EnhancedLabel.Effect>> */);
    get labelingHorizontalAlignment(): any/* MutableProperty<number> */;
    set labelingHorizontalAlignment(value: any/* MutableProperty<number> */);
    get labelingVerticalAlignment(): any/* MutableProperty<number> */;
    set labelingVerticalAlignment(value: any/* MutableProperty<number> */);
    get labelingRendering(): any/* MutableProperty<Nullable<EnhancedLabel.Rendering>> */;
    set labelingRendering(value: any/* MutableProperty<Nullable<EnhancedLabel.Rendering>> */);
    get headerEffect(): any/* MutableProperty<Nullable<EnhancedLabel.Effect>> */;
    set headerEffect(value: any/* MutableProperty<Nullable<EnhancedLabel.Effect>> */);
    get headerHorizontalAlignment(): any/* MutableProperty<number> */;
    set headerHorizontalAlignment(value: any/* MutableProperty<number> */);
    get headerVerticalAlignment(): any/* MutableProperty<number> */;
    set headerVerticalAlignment(value: any/* MutableProperty<number> */);
    get headerRendering(): any/* MutableProperty<Nullable<EnhancedLabel.Rendering>> */;
    set headerRendering(value: any/* MutableProperty<Nullable<EnhancedLabel.Rendering>> */);
    get tooltipRendering(): any/* MutableProperty<Nullable<EnhancedLabel.Rendering>> */;
    set tooltipRendering(value: any/* MutableProperty<Nullable<EnhancedLabel.Rendering>> */);
    protected get _algorithm(): any/* MutableProperty<Nullable<Algorithm>> */;
    protected set _algorithm(value: any/* MutableProperty<Nullable<Algorithm>> */);
    protected get _aggregation(): any/* MutableProperty<Nullable<Aggregation>> */;
    protected set _aggregation(value: any/* MutableProperty<Nullable<Aggregation>> */);
    protected get _scale(): any/* MutableProperty<Nullable<Scale>> */;
    protected set _scale(value: any/* MutableProperty<Nullable<Scale>> */);
    protected get _nesting(): any/* MutableProperty<Nullable<Nesting>> */;
    protected set _nesting(value: any/* MutableProperty<Nullable<Nesting>> */);
    protected get _ordering(): any/* MutableProperty<Nullable<Ordering>> */;
    protected set _ordering(value: any/* MutableProperty<Nullable<Ordering>> */);
    protected get orderingDirection(): any/* MutableProperty<Nullable<Ordering.SortOrder>> */;
    protected set orderingDirection(value: any/* MutableProperty<Nullable<Ordering.SortOrder>> */);
    protected get orderingHorizontalVanishingPoint(): any/* MutableProperty<number> */;
    protected set orderingHorizontalVanishingPoint(value: any/* MutableProperty<number> */);
    protected get orderingVerticalVanishingPoint(): any/* MutableProperty<number> */;
    protected set orderingVerticalVanishingPoint(value: any/* MutableProperty<number> */);
    protected get _labeling(): any/* MutableProperty<Nullable<Labeling>> */;
    protected set _labeling(value: any/* MutableProperty<Nullable<Labeling>> */);
    protected get _labelingFont(): any/* MutableProperty<Nullable<CPFont>> */;
    protected set _labelingFont(value: any/* MutableProperty<Nullable<CPFont>> */);
    protected get _labelingForeground(): any/* MutableProperty<Nullable<CPColor>> */;
    protected set _labelingForeground(value: any/* MutableProperty<Nullable<CPColor>> */);
    protected get _labelingBackground(): any/* MutableProperty<Nullable<CPColor>> */;
    protected set _labelingBackground(value: any/* MutableProperty<Nullable<CPColor>> */);
    protected get labelingMinimumCharactersToDisplay(): any/* MutableProperty<Nullable<number>> */;
    protected set labelingMinimumCharactersToDisplay(value: any/* MutableProperty<Nullable<number>> */);
    protected get labelingEffectOpacity(): any/* MutableProperty<Nullable<number>> */;
    protected set labelingEffectOpacity(value: any/* MutableProperty<Nullable<number>> */);
    protected get labelingShrinkTextToFitShape(): any/* MutableProperty<boolean> */;
    protected set labelingShrinkTextToFitShape(value: any/* MutableProperty<boolean> */);
    protected get labelingResizeTextToFitShape(): any/* MutableProperty<boolean> */;
    protected set labelingResizeTextToFitShape(value: any/* MutableProperty<boolean> */);
    protected get labelingFloat(): any/* MutableProperty<Nullable<boolean>> */;
    protected set labelingFloat(value: any/* MutableProperty<Nullable<boolean>> */);
    protected get labelingContrastEnhancement(): any/* MutableProperty<Nullable<ContrastEnhancement>> */;
    protected set labelingContrastEnhancement(value: any/* MutableProperty<Nullable<ContrastEnhancement>> */);
    protected get nestingAmount(): any/* MutableProperty<Nullable<number>> */;
    protected set nestingAmount(value: any/* MutableProperty<Nullable<number>> */);
    protected get nestingBackground(): any/* MutableProperty<Nullable<CPColor>> */;
    protected set nestingBackground(value: any/* MutableProperty<Nullable<CPColor>> */);
    protected get _headerFont(): any/* MutableProperty<Nullable<CPFont>> */;
    protected set _headerFont(value: any/* MutableProperty<Nullable<CPFont>> */);
    protected get _headerForeground(): any/* MutableProperty<Nullable<CPColor>> */;
    protected set _headerForeground(value: any/* MutableProperty<Nullable<CPColor>> */);
    protected get _headerEffectColor(): any/* MutableProperty<Nullable<CPColor>> */;
    protected set _headerEffectColor(value: any/* MutableProperty<Nullable<CPColor>> */);
    protected get _headerBackground(): any/* MutableProperty<Nullable<CPColor>> */;
    protected set _headerBackground(value: any/* MutableProperty<Nullable<CPColor>> */);
    protected get headerMinimumCharactersToDisplay(): any/* MutableProperty<Nullable<number>> */;
    protected set headerMinimumCharactersToDisplay(value: any/* MutableProperty<Nullable<number>> */);
    protected get headerEffectOpacity(): any/* MutableProperty<Nullable<number>> */;
    protected set headerEffectOpacity(value: any/* MutableProperty<Nullable<number>> */);
    protected get headerInsets(): any/* MutableProperty<Nullable<Insets>> */;
    protected set headerInsets(value: any/* MutableProperty<Nullable<Insets>> */);
    protected get tooltipFont(): any/* MutableProperty<Nullable<CPFont>> */;
    protected set tooltipFont(value: any/* MutableProperty<Nullable<CPFont>> */);
    protected get tooltipForeground(): any/* MutableProperty<Nullable<CPColor>> */;
    protected set tooltipForeground(value: any/* MutableProperty<Nullable<CPColor>> */);
    protected get tooltipShowLabel(): any/* MutableProperty<boolean> */;
    protected set tooltipShowLabel(value: any/* MutableProperty<boolean> */);
    protected get borderColor(): any/* MutableProperty<Nullable<CPColor>> */;
    protected set borderColor(value: any/* MutableProperty<Nullable<CPColor>> */);
    protected get _borderThickness(): any/* MutableProperty<Nullable<number>> */;
    protected set _borderThickness(value: any/* MutableProperty<Nullable<number>> */);
    protected get format(): Nullable<any>/* Nullable<MutableProperty<Nullable<CPFormat<Nullable<any>>>>> */;
    protected set format(value: Nullable<any>/* Nullable<MutableProperty<Nullable<CPFormat<Nullable<any>>>>> */);
    protected get colorMap(): Nullable<any>/* Nullable<MutableProperty<Nullable<MutableColorMap>>> */;
    protected set colorMap(value: Nullable<any>/* Nullable<MutableProperty<Nullable<MutableColorMap>>> */);
    getAlgorithmProperty(): any/* MutableProperty<Nullable<Algorithm>> */;
    getAlgorithm(): any/* Algorithm */;
    setAlgorithm(algorithm: Nullable<any>/* Nullable<Algorithm> */): void;
    getAlgorithmSelection(): any/* MutableSingleSelection<Nullable<Algorithm>> */;
    getAggregationProperty(): any/* MutableProperty<Nullable<Aggregation>> */;
    getAggregation(): Nullable<any>/* Nullable<Aggregation> */;
    setAggregation(aggregation: Nullable<any>/* Nullable<Aggregation> */): void;
    getScaleProperty(): any/* MutableProperty<Nullable<Scale>> */;
    getScale(): any/* Scale */;
    setScale(scale: Nullable<any>/* Nullable<Scale> */): void;
    getNestingProperty(): any/* MutableProperty<Nullable<Nesting>> */;
    getNesting(): Nullable<any>/* Nullable<Nesting> */;
    setNesting(nesting: Nullable<any>/* Nullable<Nesting> */): void;
    getOrderingProperty(): any/* MutableProperty<Nullable<Ordering>> */;
    getOrdering(): any/* Ordering */;
    setOrdering(ordering: Nullable<any>/* Nullable<Ordering> */): void;
    getOrderingDirectionProperty(): any/* MutableProperty<Nullable<Ordering.SortOrder>> */;
    getOrderingDirection(): Nullable<any>/* Nullable<Ordering.SortOrder> */;
    setOrderingDirection(sortOrder: Nullable<any>/* Nullable<Ordering.SortOrder> */): void;
    getOrderingVerticalVanishingPointProperty(): any/* MutableProperty<number> */;
    getOrderingVerticalVanishingPoint(): number;
    setOrderingVerticalVanishingPoint(verticalVanishingPoint: number): void;
    getOrderingHorizontalVanishingPointProperty(): any/* MutableProperty<number> */;
    getOrderingHorizontalVanishingPoint(): number;
    setOrderingHorizontalVanishingPoint(horizontalVanishingPoint: number): void;
    getLabelingProperty(): any/* MutableProperty<Nullable<Labeling>> */;
    getLabeling(): Nullable<any>/* Nullable<Labeling> */;
    setLabeling(labeling: Nullable<any>/* Nullable<Labeling> */): void;
    getLabelingFontProperty(): any/* MutableProperty<Nullable<CPFont>> */;
    getLabelingFont(): Nullable<any>/* Nullable<CPFont> */;
    setLabelingFont(font: Nullable<any>/* Nullable<CPFont> */): void;
    getLabelingForegroundProperty(): any/* MutableProperty<Nullable<CPColor>> */;
    getLabelingForeground(): Nullable<any>/* Nullable<CPColor> */;
    setLabelingForeground(color: Nullable<any>/* Nullable<CPColor> */): void;
    getLabelingEffectColorProperty(): any/* MutableProperty<Nullable<CPColor>> */;
    getLabelingEffectColor(): Nullable<any>/* Nullable<CPColor> */;
    setLabelingEffectColor(color: Nullable<any>/* Nullable<CPColor> */): void;
    getLabelingEffectProperty(): any/* MutableProperty<Nullable<EnhancedLabel.Effect>> */;
    getLabelingEffect(): Nullable<EnhancedLabel.Effect>;
    setLabelingEffect(effect: Nullable<EnhancedLabel.Effect>): void;
    getLabelingHorizontalAlignmentProperty(): any/* MutableProperty<number> */;
    getLabelingHorizontalAlignment(): number;
    setLabelingHorizontalAlignment(alignment: number): void;
    getLabelingVerticalAlignmentProperty(): any/* MutableProperty<number> */;
    getLabelingVerticalAlignment(): number;
    setLabelingVerticalAlignment(alignment: number): void;
    getLabelingRenderingProperty(): any/* MutableProperty<Nullable<EnhancedLabel.Rendering>> */;
    getLabelingRendering(): Nullable<EnhancedLabel.Rendering>;
    setLabelingRendering(rendering: Nullable<EnhancedLabel.Rendering>): void;
    getLabelingMinimumCharactersToDisplayProperty(): any/* MutableProperty<Nullable<number>> */;
    getLabelingMinimumCharactersToDisplay(): Nullable<number>;
    setLabelingMinimumCharactersToDisplay(minimumCharactersToDisplay: Nullable<number>): void;
    getLabelingEffectOpacityProperty(): any/* MutableProperty<Nullable<number>> */;
    getLabelingEffectOpacity(): Nullable<number>;
    setLabelingEffectOpacity(opacity: Nullable<number>): void;
    getLabelingShrinkTextToFitShapeProperty(): any/* MutableProperty<boolean> */;
    getLabelingShrinkTextToFitShape(): Nullable<boolean>;
    setLabelingShrinkTextToFitShape(labelingShrinkTextToFitShape: boolean): void;
    getLabelingResizeTextToFitShapeProperty(): any/* MutableProperty<boolean> */;
    getLabelingResizeTextToFitShape(): Nullable<boolean>;
    setLabelingResizeTextToFitShape(labelingResizeTextToFitShape: boolean): void;
    getLabelingFloatProperty(): any/* MutableProperty<Nullable<boolean>> */;
    getLabelingFloat(): Nullable<boolean>;
    setLabelingFloat(labelingFloat: Nullable<boolean>): void;
    getLabelingContrastEnhancementProperty(): any/* MutableProperty<Nullable<ContrastEnhancement>> */;
    getLabelingContrastEnhancement(): Nullable<any>/* Nullable<ContrastEnhancement> */;
    setLabelingContrastEnhancement(contrastEnhancement: Nullable<any>/* Nullable<ContrastEnhancement> */): void;
    getNestingAmountProperty(): any/* MutableProperty<Nullable<number>> */;
    getNestingAmount(): Nullable<number>;
    setNestingAmount(amount: Nullable<number>): void;
    getNestingBackgroundProperty(): any/* MutableProperty<Nullable<CPColor>> */;
    getNestingBackground(): Nullable<any>/* Nullable<CPColor> */;
    setNestingBackground(color: Nullable<any>/* Nullable<CPColor> */): void;
    getHeaderFontProperty(): any/* MutableProperty<Nullable<CPFont>> */;
    getHeaderFont(): Nullable<any>/* Nullable<CPFont> */;
    setHeaderFont(font: Nullable<any>/* Nullable<CPFont> */): void;
    getHeaderForegroundProperty(): any/* MutableProperty<Nullable<CPColor>> */;
    getHeaderForeground(): Nullable<any>/* Nullable<CPColor> */;
    setHeaderForeground(color: Nullable<any>/* Nullable<CPColor> */): void;
    getHeaderBackgroundProperty(): any/* MutableProperty<Nullable<CPColor>> */;
    getHeaderBackground(): Nullable<any>/* Nullable<CPColor> */;
    setHeaderBackground(color: Nullable<any>/* Nullable<CPColor> */): void;
    getHeaderEffectColorProperty(): any/* MutableProperty<Nullable<CPColor>> */;
    getHeaderEffectColor(): Nullable<any>/* Nullable<CPColor> */;
    setHeaderEffectColor(color: Nullable<any>/* Nullable<CPColor> */): void;
    getHeaderEffectProperty(): any/* MutableProperty<Nullable<EnhancedLabel.Effect>> */;
    getHeaderEffect(): Nullable<EnhancedLabel.Effect>;
    setHeaderEffect(effect: Nullable<EnhancedLabel.Effect>): void;
    getHeaderHorizontalAlignmentProperty(): any/* MutableProperty<number> */;
    getHeaderHorizontalAlignment(): number;
    setHeaderHorizontalAlignment(alignment: number): void;
    getHeaderVerticalAlignmentProperty(): any/* MutableProperty<number> */;
    getHeaderVerticalAlignment(): number;
    setHeaderVerticalAlignment(alignment: number): void;
    getHeaderRenderingProperty(): any/* MutableProperty<Nullable<EnhancedLabel.Rendering>> */;
    getHeaderRendering(): Nullable<EnhancedLabel.Rendering>;
    setHeaderRendering(rendering: Nullable<EnhancedLabel.Rendering>): void;
    getHeaderMinimumCharactersToDisplayProperty(): any/* MutableProperty<Nullable<number>> */;
    getHeaderMinimumCharactersToDisplay(): Nullable<number>;
    setHeaderMinimumCharactersToDisplay(minimumCharactersToDisplay: Nullable<number>): void;
    getHeaderEffectOpacityProperty(): any/* MutableProperty<Nullable<number>> */;
    getHeaderEffectOpacity(): Nullable<number>;
    setHeaderEffectOpacity(opacity: Nullable<number>): void;
    getHeaderInsetsProperty(): any/* MutableProperty<Nullable<Insets>> */;
    getHeaderInsets(): Nullable<any>/* Nullable<Insets> */;
    setHeaderInsets(insets: Nullable<any>/* Nullable<Insets> */): void;
    getTooltipFontProperty(): any/* MutableProperty<Nullable<CPFont>> */;
    getTooltipFont(): Nullable<any>/* Nullable<CPFont> */;
    setTooltipFont(font: Nullable<any>/* Nullable<CPFont> */): void;
    getTooltipForegroundProperty(): any/* MutableProperty<Nullable<CPColor>> */;
    getTooltipForeground(): Nullable<any>/* Nullable<CPColor> */;
    setTooltipForeground(color: Nullable<any>/* Nullable<CPColor> */): void;
    getTooltipRenderingProperty(): any/* MutableProperty<Nullable<EnhancedLabel.Rendering>> */;
    getTooltipRendering(): Nullable<EnhancedLabel.Rendering>;
    setTooltipRendering(rendering: Nullable<EnhancedLabel.Rendering>): void;
    getBorderColorProperty(): any/* MutableProperty<Nullable<CPColor>> */;
    getBorderColor(): Nullable<any>/* Nullable<CPColor> */;
    setBorderColor(color: Nullable<any>/* Nullable<CPColor> */): void;
    getBorderThicknessInterval(): any/* MutableBoundedInterval */;
    getBorderThickness(): number;
    setBorderThickness(value: number): void;
    getFormatProperty(): any/* MutableProperty<Nullable<CPFormat<Nullable<any>>>> */;
    getFormat(): Nullable<any>/* Nullable<CPFormat<Nullable<any>>> */;
    setFormat(format: Nullable<any>/* Nullable<CPFormat<Nullable<any>>> */): void;
    getShowLabelProperty(): any/* MutableProperty<boolean> */;
    getShowLabel(): boolean;
    setShowLabel(show: boolean): void;
    getColorMapProperty(): Nullable<any>/* Nullable<MutableProperty<Nullable<MutableColorMap>>> */;
    getColorMap(): Nullable<MutableColorMap>;
    setColorMap(colorMap: Nullable<MutableColorMap>): void;
    getProperty(key: Nullable<string>): any;
    isDefaults(): boolean;
    getOverrideDefaultsProperty(): Nullable<any>/* Nullable<MutableProperty<boolean>> */;
    isOverrideDefaults(): boolean;
    setOverrideDefaults(overrideDefaults: boolean): void;
    getPropertyOverride(key: Nullable<string>): any;
    reset(): void;
    protected createDefaultColorMap(column: Nullable<any>): Nullable<MutableColorMap>;
    setProperty(property: Nullable<string>, value: Nullable<any>): void;
    readonly __doNotUseOrImplementIt: TreeMapColumnSettings["__doNotUseOrImplementIt"];
    static get Companion(): {
        getDefaultTooltipFont(fontFactory: any/* CPFontFactory */): any/* CPFont */;
        getDefaultLabelingFont(fontFactory: any/* CPFontFactory */): any/* CPFont */;
        getDefaultHeaderFont(fontFactory: any/* CPFontFactory */): any/* CPFont */;
    };
}
export declare class DefaultTreeMapModel<Row, Column> /* extends AbstractTreeMapModel<Row, Column> */ implements TreeMapModel<any/* AbstractTreeMapNode<Row, Column> */, Row, Column> {
    constructor(dataFrame: any/* DataFrame<Row, Column, Nullable<any>> */);
    get dataFrame(): Nullable<any>/* Nullable<DataFrame<Row, Column, Nullable<any>>> */;
    set dataFrame(value: Nullable<any>/* Nullable<DataFrame<Row, Column, Nullable<any>>> */);
    get dataFrameListener(): any/* DataFrameListener<Row, Column> */;
    getLabelName(node: any/* AbstractTreeMapNode<Row, Column> */): Nullable<string>;
    getParent(node: any/* AbstractTreeMapNode<Row, Column> */): Nullable<any>/* Nullable<AbstractTreeMapNode<Row, Column>> */;
    isRoot(node: any/* AbstractTreeMapNode<Row, Column> */): boolean;
    getChildCount(node: any/* AbstractTreeMapNode<Row, Column> */): number;
    getChildren(parent: any/* AbstractTreeMapNode<Row, Column> */): any/* Iterable<AbstractTreeMapNode<Row, Column>> */;
    getChildrenOfTypeParent(parent: any/* AbstractTreeMapNode<Row, Column> */): any/* Iterable<AbstractTreeMapNode<Row, Column>> */;
    getCushionImage(node: any/* AbstractTreeMapNode<Row, Column> */): Nullable<any>/* Nullable<CPImage> */;
    getCushionColor(node: any/* AbstractTreeMapNode<Row, Column> */): Nullable<any>/* Nullable<CPColor> */;
    protected createLeafNode(row: Row): any/* AbstractTreeMapNode<Row, Column> */;
    getNodeForRow(row: Row): any/* AbstractTreeMapNode<Row, Column> */;
    protected createParentNode(name: any, groupByColumn: Column, childrenGroupByColumn: Nullable<Column>): any/* AbstractTreeMapNode<Row, Column> */;
    protected findChild(parent: any/* AbstractTreeMapNode<Row, Column> */, name: Nullable<any>): Nullable<any>/* Nullable<AbstractTreeMapNode<Row, Column>> */;
    protected addChildToParent(parent: any/* AbstractTreeMapNode<Row, Column> */, child: any/* AbstractTreeMapNode<Row, Column> */): void;
    protected addChild(parent: any/* AbstractTreeMapNode<Row, Column> */, path: any/* Iterable<Nullable<any>> */, groupBy: any/* Iterable<Column> */, childrenGroupBy: any/* Iterable<Nullable<Column>> */, row: Row): void;
    getTreeMapColumn(columnIndex: number): Nullable<Column>;
    getTreeMapColumnByName(columnName: Nullable<string>): Nullable<Column>;
    get rowCount(): number;
    get columnCount(): number;
    columns(): any/* Iterable<Column> */;
    getColumnName(columnIndex: Column): Nullable<string>;
    getColumnClass(columnIndex: Column): any/* KClass<UnknownType *> */;
    getValueAt(node: any/* AbstractTreeMapNode<Row, Column> */, columnIndex: Column): Nullable<any>;
    isEveryValueUnique(column: Nullable<Column>): boolean;
    getNumericMax(columnIndex: Nullable<Column>): Nullable<number>;
    getNumericMin(columnIndex: Nullable<Column>): Nullable<number>;
    setNumericMax(columnIndex: Nullable<Column>, max: number): void;
    setNumericMin(columnIndex: Nullable<Column>, min: number): void;
    createDefaultColorMap(column: Column): MutableColorMap;
    get colorFactory(): any/* MkColorFactory */;
    get settings(): TreeMapSettings<Column>;
    get properties(): any/* MutableProperties<Nullable<string>> */;
    get probing(): any/* MutableSingleSelection<Nullable<AbstractTreeMapNode<Row, Column>>> */;
    get highlighting(): any/* MutableSelection<AbstractTreeMapNode<Row, Column>> */;
    get selection(): any/* MutableSelection<AbstractTreeMapNode<Row, Column>> */;
    get filter(): any/* MutableFilter<AbstractTreeMapNode<Row, Column>> */;
    get search(): any/* MutableFilter<AbstractTreeMapNode<Row, Column>> */;
    get isDirty(): boolean;
    get colorProvider(): any/* ColorProvider<AbstractTreeMapNode<Row, Column>> */;
    set colorProvider(value: any/* ColorProvider<AbstractTreeMapNode<Row, Column>> */);
    get groupByColumns(): any/* Iterable<Nullable<Column>> */;
    get sizeColumns(): any/* Iterable<Nullable<Column>> */;
    get colorColumns(): any/* Iterable<Nullable<Column>> */;
    get heightColumns(): any/* Iterable<Nullable<Column>> */;
    get labelsColumns(): any/* Iterable<Nullable<Column>> */;
    get tooltipColumns(): any/* Iterable<Nullable<Column>> */;
    getTreeMapColumnsInclude(includeNone: boolean): any/* Iterable<Nullable<Column>> */;
    getTreeMapColumnsByIndices(columns: Int32Array): KtList<Column>;
    getTreeMapColumns(columns: Array<Column>): KtList<Column>;
    getTreeMapColumnsByNames(columnNames: Array<Nullable<string>>): KtList<Column>;
    isNumericType(column: Column): boolean;
    isTemporalType(column: Column): boolean;
    isVisualType(column: Column): boolean;
    getSumSize(node: any/* AbstractTreeMapNode<Row, Column> */): number;
    getColorMap(column: Nullable<Column>): Nullable<MutableColorMap>;
    getCategoricalColorMap(column: Column): MutableColorMap;
    getPredefinedColorMap(column: Column): MutableColorMap;
    getCustomColorMap(column: Column): MutableColorMap;
    setNestedShape(node: any/* AbstractTreeMapNode<Row, Column> */, shape: Nullable<any>/* Nullable<Shape> */): void;
    getNestedShape(node: any/* AbstractTreeMapNode<Row, Column> */): any/* Shape */;
    getGroupByColumn(node: any/* AbstractTreeMapNode<Row, Column> */): Nullable<Column>;
    getChildrenGroupByColumn(node: any/* AbstractTreeMapNode<Row, Column> */): Nullable<Column>;
    isLeaf(node: any/* AbstractTreeMapNode<Row, Column> */): boolean;
    parentPreorderEnumeration(parent: any/* AbstractTreeMapNode<Row, Column> */): any/* Iterable<AbstractTreeMapNode<Row, Column>> */;
    preorderEnumeration(parent: any/* AbstractTreeMapNode<Row, Column> */): any/* Iterable<AbstractTreeMapNode<Row, Column>> */;
    breadthFirstIterator(parent: any/* AbstractTreeMapNode<Row, Column> */): any/* Iterable<AbstractTreeMapNode<Row, Column>> */;
    depthFirstIterator(parent: any/* AbstractTreeMapNode<Row, Column> */): any/* Iterable<AbstractTreeMapNode<Row, Column>> */;
    getAggregateValue(node: any/* AbstractTreeMapNode<Row, Column> */, column: Nullable<Column>): Nullable<any>;
    getStringValue(node: any/* AbstractTreeMapNode<Row, Column> */, column: Column): Nullable<string>;
    get currentRoot(): Nullable<any>/* Nullable<AbstractTreeMapNode<Row, Column>> */;
    set currentRoot(value: Nullable<any>/* Nullable<AbstractTreeMapNode<Row, Column>> */);
    addListener(treeMapListener: any/* TreeMapListener */): void;
    removeListener(treeMapListener: any/* TreeMapListener */): void;
    getNode(position: Nullable<any>/* Nullable<Point> */): Nullable<any>/* Nullable<AbstractTreeMapNode<Row, Column>> */;
    waitUntilReady(): void;
    getColor(node: any/* AbstractTreeMapNode<Row, Column> */): any/* CPColor */;
    setColor(node: any/* AbstractTreeMapNode<Row, Column> */, color: Nullable<any>/* Nullable<CPColor> */): void;
    progressProperty(): any/* MutableProperty<number> */;
    getFormatPattern(columnIndex: number): Nullable<string>;
    setFormatPattern(columnIndex: number, pattern: Nullable<string>): void;
    readonly __doNotUseOrImplementIt: TreeMapModel<any/* AbstractTreeMapNode<Row, Column> */, Row, Column>["__doNotUseOrImplementIt"];
}
export declare class DefaultTreeMapSettings<N extends unknown/* MutableTreeMapNode<Column> */, Column> /* extends AbstractTreeMapSettings<Column> */ implements TreeMapSettings<Column> {
    constructor(model: TreeMapModel<N, any /*UnknownType **/, Column>, colorFactory: any/* MkColorFactory */, fontFactory: any/* CPFontFactory */, colorMapFactory: any/* ColorMapFactory */);
    get properties(): any/* MutableProperties<Nullable<string>> */;
    protected get _model(): TreeMapModel<N, any /*UnknownType **/, Column>;
    protected get groupByVariables(): any/* MutableSelection<Column> */;
    protected get sizeVariable(): any/* MutableSingleSelection<Nullable<Column>> */;
    protected get colorVariable(): any/* MutableSingleSelection<Nullable<Column>> */;
    protected get labelVariable(): any/* MutableSelection<Column> */;
    protected get toolTipVariable(): any/* MutableSelection<Column> */;
    protected get backgroundVariable(): any/* MutableSingleSelection<Nullable<Column>> */;
    protected get heightVariable(): any/* MutableSingleSelection<Nullable<Column>> */;
    protected get progressive(): any/* MutableSingleSelection<Nullable<Progressive>> */;
    protected get depth(): any/* MutableSingleSelection<Nullable<Depth>> */;
    get renderingSelection(): any/* MutableSingleSelection<Nullable<Rendering>> */;
    protected get groupByFields(): any/* MutableProperty<KtList<Column>> */;
    protected set groupByFields(value: any/* MutableProperty<KtList<Column>> */);
    get groupByColumns(): KtList<Column>;
    set groupByColumns(value: KtList<Column>);
    protected get labelsFields(): any/* MutableProperty<KtList<Column>> */;
    protected set labelsFields(value: any/* MutableProperty<KtList<Column>> */);
    get labelsColumns(): KtList<Column>;
    set labelsColumns(value: KtList<Column>);
    protected get toolTipFields(): any/* MutableProperty<KtList<Column>> */;
    protected set toolTipFields(value: any/* MutableProperty<KtList<Column>> */);
    get toolTipColumns(): KtList<Column>;
    set toolTipColumns(value: KtList<Column>);
    protected get sizeField(): any/* MutableProperty<Nullable<Column>> */;
    protected set sizeField(value: any/* MutableProperty<Nullable<Column>> */);
    get sizeColumn(): Nullable<Column>;
    set sizeColumn(value: Nullable<Column>);
    get colorColumn(): Nullable<Column>;
    set colorColumn(value: Nullable<Column>);
    protected get backgroundField(): any/* MutableProperty<Nullable<Column>> */;
    protected set backgroundField(value: any/* MutableProperty<Nullable<Column>> */);
    get backgroundColumn(): Nullable<Column>;
    set backgroundColumn(value: Nullable<Column>);
    protected get heightField(): any/* MutableProperty<Nullable<Column>> */;
    protected set heightField(value: any/* MutableProperty<Nullable<Column>> */);
    get heightColumn(): Nullable<Column>;
    set heightColumn(value: Nullable<Column>);
    protected get _depth(): any/* MutableProperty<Nullable<Depth>> */;
    protected set _depth(value: any/* MutableProperty<Nullable<Depth>> */);
    protected get _rendering(): any/* MutableProperty<Nullable<Rendering>> */;
    protected set _rendering(value: any/* MutableProperty<Nullable<Rendering>> */);
    get rendering(): Nullable<Rendering>;
    set rendering(value: Nullable<Rendering>);
    get maximumHeightInterval(): any/* MutableBoundedInterval */;
    protected get maximumHeight(): any/* MutableProperty<number> */;
    get lightSourceHeightInterval(): any/* MutableBoundedInterval */;
    set lightSourceHeightInterval(value: any/* MutableBoundedInterval */);
    protected get lightSourceHeight(): any/* MutableProperty<number> */;
    get lightSourceAmbientInterval(): any/* MutableBoundedInterval */;
    protected get lightSourceAmbient(): any/* MutableProperty<number> */;
    get lightSourceXInterval(): any/* MutableBoundedInterval */;
    protected get lightSourceX(): any/* MutableProperty<number> */;
    get lightSourceYInterval(): any/* MutableBoundedInterval */;
    protected get lightSourceY(): any/* MutableProperty<number> */;
    get lightSourceZInterval(): any/* MutableBoundedInterval */;
    protected get lightSourceZ(): any/* MutableProperty<number> */;
    protected get _background(): any/* MutableProperty<Nullable<CPColor>> */;
    protected set _background(value: any/* MutableProperty<Nullable<CPColor>> */);
    protected get _tooltipBackground(): any/* MutableProperty<Nullable<CPColor>> */;
    protected set _tooltipBackground(value: any/* MutableProperty<Nullable<CPColor>> */);
    protected get _probingColor(): any/* MutableProperty<Nullable<CPColor>> */;
    protected set _probingColor(value: any/* MutableProperty<Nullable<CPColor>> */);
    protected get _selectionColor(): any/* MutableProperty<Nullable<CPColor>> */;
    protected set _selectionColor(value: any/* MutableProperty<Nullable<CPColor>> */);
    protected get hideSearchResults(): any/* MutableProperty<Nullable<boolean>> */;
    protected set hideSearchResults(value: any/* MutableProperty<Nullable<boolean>> */);
    protected get hideFilterResults(): any/* MutableProperty<Nullable<boolean>> */;
    protected set hideFilterResults(value: any/* MutableProperty<Nullable<boolean>> */);
    getGroupByColumnsSelection(): any/* MutableSelection<Column> */;
    getSizeColumnSelection(): any/* MutableSingleSelection<Nullable<Column>> */;
    getColorColumnSelection(): any/* MutableSingleSelection<Nullable<Column>> */;
    getLabelColumnsSelection(): any/* MutableSelection<Column> */;
    getTooltipColumnsSelection(): any/* MutableSelection<Column> */;
    getBackgroundColumnSelection(): any/* MutableSingleSelection<Nullable<Column>> */;
    getHeightColumnSelection(): any/* MutableSingleSelection<Nullable<Column>> */;
    getDepthSelection(): any/* MutableSingleSelection<Nullable<Depth>> */;
    getProgressiveSelection(): any/* MutableSingleSelection<Nullable<Progressive>> */;
    getHideFilterResultsSelection(): any/* MutableProperty<Nullable<boolean>> */;
    getHideSearchResultsSelection(): any/* MutableProperty<Nullable<boolean>> */;
    protected createDefaultTreeMapColumnSettings(): TreeMapColumnSettings;
    protected createOverridingTreeMapColumnSettings(defaultSettings: TreeMapColumnSettings, model: Nullable<TreeMapModel<N, any /*UnknownType **/, Column>>, field: Nullable<Column>): TreeMapColumnSettings;
    getDefaultColumnSettings(): TreeMapColumnSettings;
    getColumnSettings(field: Nullable<Column>): TreeMapColumnSettings;
    getDimensionFixed(): Nullable<boolean>;
    setDimensionFixed(fixed: Nullable<boolean>): void;
    getDimension(): Nullable<any>/* Nullable<Dimension> */;
    setDimension(dimension: Nullable<any>/* Nullable<Dimension> */): void;
    getProgressive(): Nullable<any>/* Nullable<Progressive> */;
    setProgressive(progressive: Nullable<any>/* Nullable<Progressive> */): void;
    getMaximumHeight(): number;
    setMaximumHeight(height: number): void;
    isHideFilterResults(): Nullable<boolean>;
    isHideSearchResults(): Nullable<boolean>;
    setGroupBy(columns: Int32Array): void;
    setGroupByByNames(columnNames: Array<Nullable<string>>): void;
    setLabels(columns: Int32Array): void;
    setLabelsByNames(columnNames: Array<Nullable<string>>): void;
    setToolTip(columns: Int32Array): void;
    setToolTipByNames(columns: Array<Nullable<string>>): void;
    getShowPopup(field: Nullable<Column>): boolean;
    setShowPopup(field: Nullable<Column>, show: boolean): void;
    setBackground(column: number): void;
    setBackgroundByName(columnName: Nullable<string>): void;
    setSize(column: number): void;
    setSizeByName(columnName: Nullable<string>): void;
    setColor(column: number): void;
    setColorByName(columnName: Nullable<string>): void;
    setHeight(column: number): void;
    setHeightByName(columnName: Nullable<string>): void;
    getDepth(): Nullable<any>/* Nullable<Depth> */;
    setDepth(depth: Nullable<any>/* Nullable<Depth> */): void;
    setHideFilterResults(hideFilterResults: Nullable<boolean>): void;
    setHideSearchResults(hideSearchResults: Nullable<boolean>): void;
    getLightSourceHeight(): number;
    setLightSourceHeight(value: number): void;
    getLightSourceAmbient(): number;
    setLightSourceAmbient(value: number): void;
    getLightSourceX(): number;
    setLightSourceX(value: number): void;
    getLightSourceY(): number;
    setLightSourceY(value: number): void;
    getLightSourceZ(): number;
    setLightSourceZ(value: number): void;
    getBackgroundProperty(): any/* MutableProperty<Nullable<CPColor>> */;
    getBackground(): Nullable<any>/* Nullable<CPColor> */;
    setBackgroundColor(color: Nullable<any>/* Nullable<CPColor> */): void;
    getTooltipBackgroundProperty(): any/* MutableProperty<Nullable<CPColor>> */;
    getTooltipBackground(): Nullable<any>/* Nullable<CPColor> */;
    setTooltipBackground(color: Nullable<any>/* Nullable<CPColor> */): void;
    getProbingColorProperty(): any/* MutableProperty<Nullable<CPColor>> */;
    getProbingColor(): Nullable<any>/* Nullable<CPColor> */;
    setProbingColor(color: Nullable<any>/* Nullable<CPColor> */): void;
    getSelectionColorProperty(): any/* MutableProperty<Nullable<CPColor>> */;
    getSelectionColor(): Nullable<any>/* Nullable<CPColor> */;
    setSelectionColor(color: Nullable<any>/* Nullable<CPColor> */): void;
    getValue(key: Nullable<string>): Nullable<any>;
    resetToDefaults(): void;
    save(dataFrame: any/* DataFrame<Nullable<any>, Column, Nullable<any>> */, elementFactory: any/* ElementFactory */, root: any/* Element */): void;
    addTreeMapSettingsListener(listener: any/* TreeMapSettingsListener */): void;
    removeTreeMapSettingsListener(listener: any/* TreeMapSettingsListener */): void;
    removeTreeMapSettingsListeners(): void;
    readonly __doNotUseOrImplementIt: TreeMapSettings<Column>["__doNotUseOrImplementIt"];
}
export declare class FlatNoBorderRendering extends FlatRendering {
    constructor();
    toString(): string;
    getPasses<N, Row, Column>(model: TreeMapModel<N, Row, Column>): number;
    getParentOrder<N, Row, Column>(view: any/* TreeMapView<N, Row, Column> */, root: N, pass: number): any/* Iterable<N> */;
    getOrder<N, Row, Column>(view: any/* TreeMapView<N, Row, Column> */, root: N, pass: number): any/* Iterable<N> */;
    paintParent<N, Row, Column>(g: any/* TGraphics */, view: any/* TreeMapView<N, Row, Column> */, node: N, pass: number, bounds: any/* Rectangle */, shape: any/* Shape */): void;
    getRenderedShape<N, Row, Column>(view: any/* TreeMapView<N, Row, Column> */, model: TreeMapModel<N, Row, Column>, node: N, shape: any/* Shape */): any/* Shape */;
    paintBackground<N, Row, Column>(g: any/* TGraphics */, view: any/* TreeMapView<N, Row, Column> */, node: N, pass: number, passes: number, bounds: any/* Rectangle */, shape: any/* Shape */): void;
    getNestingBackground<N, Row, Column>(node: N, model: TreeMapModel<N, Row, Column>): Nullable<any>/* Nullable<CPColor> */;
    paintLabel<N, Row, Column>(g: any/* TGraphics */, view: any/* TreeMapView<N, Row, Column> */, node: N, pass: number, passes: number, bounds: any/* Rectangle */, shape: any/* Shape */): void;
    paintParentBorder<N, Row, Column>(g: any/* TGraphics */, node: N, bounds: any/* Rectangle */, shape: any/* Shape */, model: TreeMapModel<N, Row, Column>): void;
    paintParentHighlight<N, Row, Column>(g2: any/* TGraphics */, view: any/* TreeMapView<N, Row, Column> */, node: N, pass: number, bounds: any/* Rectangle */, shape: Nullable<any>/* Nullable<Shape> */): void;
}
export declare class FlatRendering /* extends AbstractRendering */ implements Rendering {
    constructor();
    get drawBorder(): boolean;
    set drawBorder(value: boolean);
    paintNode<N, Row, Column>(g: any/* TGraphics */, view: any/* TreeMapView<N, Row, Column> */, node: N, pass: number, bounds: any/* Rectangle */, shape: any/* Shape */): boolean;
    paintBorder<N, Row, Column>(g2: any/* TGraphics */, view: any/* TreeMapView<N, Row, Column> */, node: N, pass: number, bounds: any/* Rectangle */, shape: any/* Shape */): void;
    toString(): string;
    getPasses<N, Row, Column>(model: TreeMapModel<N, Row, Column>): number;
    getParentOrder<N, Row, Column>(view: any/* TreeMapView<N, Row, Column> */, root: N, pass: number): any/* Iterable<N> */;
    getOrder<N, Row, Column>(view: any/* TreeMapView<N, Row, Column> */, root: N, pass: number): any/* Iterable<N> */;
    paintParent<N, Row, Column>(g: any/* TGraphics */, view: any/* TreeMapView<N, Row, Column> */, node: N, pass: number, bounds: any/* Rectangle */, shape: any/* Shape */): void;
    getRenderedShape<N, Row, Column>(view: any/* TreeMapView<N, Row, Column> */, model: TreeMapModel<N, Row, Column>, node: N, shape: any/* Shape */): any/* Shape */;
    paintBackground<N, Row, Column>(g: any/* TGraphics */, view: any/* TreeMapView<N, Row, Column> */, node: N, pass: number, passes: number, bounds: any/* Rectangle */, shape: any/* Shape */): void;
    getNestingBackground<N, Row, Column>(node: N, model: TreeMapModel<N, Row, Column>): Nullable<any>/* Nullable<CPColor> */;
    paintLabel<N, Row, Column>(g: any/* TGraphics */, view: any/* TreeMapView<N, Row, Column> */, node: N, pass: number, passes: number, bounds: any/* Rectangle */, shape: any/* Shape */): void;
    paintParentBorder<N, Row, Column>(g: any/* TGraphics */, node: N, bounds: any/* Rectangle */, shape: any/* Shape */, model: TreeMapModel<N, Row, Column>): void;
    paintParentHighlight<N, Row, Column>(g2: any/* TGraphics */, view: any/* TreeMapView<N, Row, Column> */, node: N, pass: number, bounds: any/* Rectangle */, shape: Nullable<any>/* Nullable<Shape> */): void;
    readonly __doNotUseOrImplementIt: Rendering["__doNotUseOrImplementIt"];
}
export declare class OverridingTreeMapColumnSettings /* extends AbstractTreeMapColumnSettings */ implements TreeMapColumnSettings {
    constructor(defaultSettings: TreeMapColumnSettings);
    get properties(): any/* OverrideProperties */;
    isDefaults(): boolean;
    isOverrideDefaults(): boolean;
    getOverrideDefaultsProperty(): any/* MutableProperty<boolean> */;
    setOverrideDefaults(overrideDefaults: boolean): void;
    getAlgorithmProperty(): any/* MutableProperty<Nullable<Algorithm>> */;
    getAlgorithm(): any/* Algorithm */;
    setAlgorithm(algorithm: Nullable<any>/* Nullable<Algorithm> */): void;
    getAggregationProperty(): any/* MutableProperty<Nullable<Aggregation>> */;
    getAggregation(): Nullable<any>/* Nullable<Aggregation> */;
    setAggregation(aggregation: Nullable<any>/* Nullable<Aggregation> */): void;
    getScaleProperty(): any/* MutableProperty<Nullable<Scale>> */;
    getScale(): Nullable<any>/* Nullable<Scale> */;
    setScale(scale: Nullable<any>/* Nullable<Scale> */): void;
    getNestingProperty(): any/* MutableProperty<Nullable<Nesting>> */;
    getNesting(): Nullable<any>/* Nullable<Nesting> */;
    setNesting(nesting: Nullable<any>/* Nullable<Nesting> */): void;
    getOrderingProperty(): any/* MutableProperty<Nullable<Ordering>> */;
    getOrdering(): any/* Ordering */;
    setOrdering(ordering: Nullable<any>/* Nullable<Ordering> */): void;
    getOrderingDirectionProperty(): any/* MutableProperty<Nullable<Ordering.SortOrder>> */;
    getOrderingDirection(): Nullable<any>/* Nullable<Ordering.SortOrder> */;
    setOrderingDirection(ordering: Nullable<any>/* Nullable<Ordering.SortOrder> */): void;
    getOrderingVerticalVanishingPointProperty(): any/* MutableProperty<number> */;
    getOrderingVerticalVanishingPoint(): number;
    setOrderingVerticalVanishingPoint(verticalVanishingPoint: number): void;
    getOrderingHorizontalVanishingPointProperty(): any/* MutableProperty<number> */;
    getOrderingHorizontalVanishingPoint(): number;
    setOrderingHorizontalVanishingPoint(horizontalVanishingPoint: number): void;
    getLabelingProperty(): any/* MutableProperty<Nullable<Labeling>> */;
    getLabeling(): Nullable<any>/* Nullable<Labeling> */;
    setLabeling(labeling: Nullable<any>/* Nullable<Labeling> */): void;
    getLabelingFontProperty(): any/* MutableProperty<Nullable<CPFont>> */;
    getLabelingFont(): any/* CPFont */;
    setLabelingFont(font: Nullable<any>/* Nullable<CPFont> */): void;
    getLabelingForegroundProperty(): any/* MutableProperty<Nullable<CPColor>> */;
    getLabelingForeground(): any/* CPColor */;
    setLabelingForeground(color: Nullable<any>/* Nullable<CPColor> */): void;
    getLabelingEffectColorProperty(): any/* MutableProperty<Nullable<CPColor>> */;
    getLabelingEffectColor(): Nullable<any>/* Nullable<CPColor> */;
    setLabelingEffectColor(color: Nullable<any>/* Nullable<CPColor> */): void;
    getLabelingEffectProperty(): any/* MutableProperty<Nullable<EnhancedLabel.Effect>> */;
    getLabelingEffect(): Nullable<EnhancedLabel.Effect>;
    setLabelingEffect(effect: Nullable<EnhancedLabel.Effect>): void;
    getLabelingHorizontalAlignmentProperty(): any/* MutableProperty<number> */;
    getLabelingHorizontalAlignment(): number;
    setLabelingHorizontalAlignment(alignment: number): void;
    getLabelingVerticalAlignmentProperty(): any/* MutableProperty<number> */;
    getLabelingVerticalAlignment(): number;
    setLabelingVerticalAlignment(alignment: number): void;
    getLabelingRenderingProperty(): any/* MutableProperty<Nullable<EnhancedLabel.Rendering>> */;
    getLabelingRendering(): EnhancedLabel.Rendering;
    setLabelingRendering(rendering: Nullable<EnhancedLabel.Rendering>): void;
    getLabelingMinimumCharactersToDisplayProperty(): any/* MutableProperty<Nullable<number>> */;
    getLabelingMinimumCharactersToDisplay(): number;
    setLabelingMinimumCharactersToDisplay(minimumCharactersToDisplay: Nullable<number>): void;
    getLabelingEffectOpacityProperty(): any/* MutableProperty<Nullable<number>> */;
    getLabelingEffectOpacity(): Nullable<number>;
    setLabelingEffectOpacity(opacity: Nullable<number>): void;
    getLabelingShrinkTextToFitShapeProperty(): any/* MutableProperty<boolean> */;
    getLabelingShrinkTextToFitShape(): boolean;
    setLabelingShrinkTextToFitShape(labelingShrinkTextToFitShape: boolean): void;
    getLabelingResizeTextToFitShapeProperty(): any/* MutableProperty<boolean> */;
    getLabelingResizeTextToFitShape(): boolean;
    setLabelingResizeTextToFitShape(labelingResizeTextToFitShape: boolean): void;
    getLabelingFloatProperty(): any/* MutableProperty<Nullable<boolean>> */;
    getLabelingFloat(): boolean;
    setLabelingFloat(labelingFloat: Nullable<boolean>): void;
    getLabelingContrastEnhancementProperty(): any/* MutableProperty<Nullable<ContrastEnhancement>> */;
    getLabelingContrastEnhancement(): any/* ContrastEnhancement */;
    setLabelingContrastEnhancement(contrastEnhancement: Nullable<any>/* Nullable<ContrastEnhancement> */): void;
    getNestingAmountProperty(): any/* MutableProperty<Nullable<number>> */;
    getNestingAmount(): number;
    setNestingAmount(amount: Nullable<number>): void;
    getNestingBackgroundProperty(): any/* MutableProperty<Nullable<CPColor>> */;
    getNestingBackground(): any/* CPColor */;
    setNestingBackground(color: Nullable<any>/* Nullable<CPColor> */): void;
    getHeaderFontProperty(): any/* MutableProperty<Nullable<CPFont>> */;
    getHeaderFont(): any/* CPFont */;
    setHeaderFont(font: Nullable<any>/* Nullable<CPFont> */): void;
    getHeaderForegroundProperty(): any/* MutableProperty<Nullable<CPColor>> */;
    getHeaderForeground(): any/* CPColor */;
    setHeaderForeground(color: Nullable<any>/* Nullable<CPColor> */): void;
    getHeaderBackgroundProperty(): any/* MutableProperty<Nullable<CPColor>> */;
    getHeaderBackground(): any/* CPColor */;
    setHeaderBackground(color: Nullable<any>/* Nullable<CPColor> */): void;
    getHeaderEffectColorProperty(): any/* MutableProperty<Nullable<CPColor>> */;
    getHeaderEffectColor(): any/* CPColor */;
    setHeaderEffectColor(color: Nullable<any>/* Nullable<CPColor> */): void;
    getHeaderEffectProperty(): any/* MutableProperty<Nullable<EnhancedLabel.Effect>> */;
    getHeaderEffect(): Nullable<EnhancedLabel.Effect>;
    setHeaderEffect(effect: Nullable<EnhancedLabel.Effect>): void;
    getHeaderHorizontalAlignmentProperty(): any/* MutableProperty<number> */;
    getHeaderHorizontalAlignment(): number;
    setHeaderHorizontalAlignment(alignment: number): void;
    getHeaderVerticalAlignmentProperty(): any/* MutableProperty<number> */;
    getHeaderVerticalAlignment(): number;
    setHeaderVerticalAlignment(alignment: number): void;
    getHeaderRenderingProperty(): any/* MutableProperty<Nullable<EnhancedLabel.Rendering>> */;
    getHeaderRendering(): Nullable<EnhancedLabel.Rendering>;
    setHeaderRendering(rendering: Nullable<EnhancedLabel.Rendering>): void;
    getHeaderMinimumCharactersToDisplayProperty(): any/* MutableProperty<Nullable<number>> */;
    getHeaderMinimumCharactersToDisplay(): Nullable<number>;
    setHeaderMinimumCharactersToDisplay(minimumCharactersToDisplay: Nullable<number>): void;
    getHeaderEffectOpacityProperty(): any/* MutableProperty<Nullable<number>> */;
    getHeaderEffectOpacity(): Nullable<number>;
    setHeaderEffectOpacity(opacity: Nullable<number>): void;
    getHeaderInsetsProperty(): any/* MutableProperty<Nullable<Insets>> */;
    getHeaderInsets(): Nullable<any>/* Nullable<Insets> */;
    setHeaderInsets(insets: Nullable<any>/* Nullable<Insets> */): void;
    getTooltipFontProperty(): any/* MutableProperty<Nullable<CPFont>> */;
    getTooltipFont(): any/* CPFont */;
    setTooltipFont(font: Nullable<any>/* Nullable<CPFont> */): void;
    getTooltipForegroundProperty(): any/* MutableProperty<Nullable<CPColor>> */;
    getTooltipForeground(): Nullable<any>/* Nullable<CPColor> */;
    setTooltipForeground(color: Nullable<any>/* Nullable<CPColor> */): void;
    getTooltipRenderingProperty(): any/* MutableProperty<Nullable<EnhancedLabel.Rendering>> */;
    getTooltipRendering(): Nullable<EnhancedLabel.Rendering>;
    setTooltipRendering(rendering: Nullable<EnhancedLabel.Rendering>): void;
    getBorderColorProperty(): any/* MutableProperty<Nullable<CPColor>> */;
    getBorderColor(): Nullable<any>/* Nullable<CPColor> */;
    setBorderColor(color: Nullable<any>/* Nullable<CPColor> */): void;
    getBorderThicknessInterval(): Nullable<any>/* Nullable<MutableBoundedInterval> */;
    getBorderThicknessProperty(): any/* MutableProperty<number> */;
    getBorderThickness(): number;
    setBorderThickness(value: number): void;
    getShowLabelProperty(): any/* MutableProperty<boolean> */;
    getShowLabel(): boolean;
    getFormatProperty(): any/* MutableProperty<Nullable<CPFormat<Nullable<any>>>> */;
    setShowLabel(show: boolean): void;
    getFormat(): Nullable<any>/* Nullable<CPFormat<Nullable<any>>> */;
    getColorMapProperty(): any/* MutableProperty<Nullable<MutableColorMap>> */;
    setFormat(format: Nullable<any>/* Nullable<CPFormat<Nullable<any>>> */): void;
    getColorMap(): Nullable<MutableColorMap>;
    setColorMap(colorMap: Nullable<MutableColorMap>): void;
    getProperty(key: Nullable<string>): Nullable<any>;
    getPropertyOverride(key: Nullable<string>): Nullable<any>;
    setProperty(key: Nullable<string>, value: Nullable<any>): void;
    setPropertyOverride(key: Nullable<string>, value: Nullable<any>): void;
    reset(): void;
    readonly __doNotUseOrImplementIt: TreeMapColumnSettings["__doNotUseOrImplementIt"];
}
export declare interface Rendering {
    getPasses<N, Row, Column>(model: TreeMapModel<N, Row, Column>): number;
    paintParent<N, Row, Column>(g: any/* TGraphics */, view: any/* TreeMapView<N, Row, Column> */, node: N, pass: number, bounds: any/* Rectangle */, shape: any/* Shape */): void;
    paintParentBorder<N, Row, Column>(g: any/* TGraphics */, node: N, bounds: any/* Rectangle */, shape: any/* Shape */, model: TreeMapModel<N, Row, Column>): void;
    paintNode<N, Row, Column>(g: any/* TGraphics */, view: any/* TreeMapView<N, Row, Column> */, node: N, pass: number, bounds: any/* Rectangle */, shape: any/* Shape */): boolean;
    paintBackground<N, Row, Column>(g: any/* TGraphics */, view: any/* TreeMapView<N, Row, Column> */, node: N, pass: number, passes: number, bounds: any/* Rectangle */, shape: any/* Shape */): void;
    paintLabel<N, Row, Column>(g: any/* TGraphics */, view: any/* TreeMapView<N, Row, Column> */, node: N, pass: number, passes: number, bounds: any/* Rectangle */, shape: any/* Shape */): void;
    paintParentHighlight<N, Row, Column>(g2: any/* TGraphics */, view: any/* TreeMapView<N, Row, Column> */, node: N, pass: number, bounds: any/* Rectangle */, shape: Nullable<any>/* Nullable<Shape> */): void;
    paintBorder<N, Row, Column>(g2: any/* TGraphics */, view: any/* TreeMapView<N, Row, Column> */, node: N, pass: number, bounds: any/* Rectangle */, shape: any/* Shape */): void;
    getParentOrder<N, Row, Column>(view: any/* TreeMapView<N, Row, Column> */, root: N, pass: number): any/* Iterable<N> */;
    getOrder<N, Row, Column>(view: any/* TreeMapView<N, Row, Column> */, root: N, pass: number): any/* Iterable<N> */;
    getRenderedShape<N, Row, Column>(view: any/* TreeMapView<N, Row, Column> */, model: TreeMapModel<N, Row, Column>, node: N, shape: any/* Shape */): any/* Shape */;
    getNestingBackground<N, Row, Column>(node: N, model: TreeMapModel<N, Row, Column>): Nullable<any>/* Nullable<CPColor> */;
    readonly __doNotUseOrImplementIt: {
        readonly "com.treemap.Rendering": unique symbol;
    };
}
export declare class RenderingFactory {
    private constructor();
    add(entry: Rendering): void;
    getDefault(): Rendering;
    getRenderings(): KtList<Rendering>;
    get(name: Nullable<string>): Rendering;
    static get Companion(): {
        get CUSHION(): Rendering;
        get FLAT(): Rendering;
        get FLAT_NO_BORDER(): Rendering;
        get instance(): RenderingFactory;
    };
}
export declare interface TreeMap<N, Row, Column> {
    readonly component: any/* CPComponent */;
    model: Nullable<TreeMapModel<N, Row, Column>>;
    view: Nullable<any>/* Nullable<TreeMapView<N, Row, Column>> */;
    controller: Nullable<any>/* Nullable<TreeMapController<N, Row, Column>> */;
    setGroupBy(columns: Int32Array): void;
    setGroupByByNames(columnNames: Array<Nullable<string>>): void;
    setLabels(columns: Int32Array): void;
    setLabelsByNames(columnNames: Array<Nullable<string>>): void;
    setBackground(column: number): void;
    setBackgroundByName(columnName: Nullable<string>): void;
    setSize(column: number): void;
    setSizeByName(columnName: Nullable<string>): void;
    setColor(column: number): void;
    setColorByName(columnName: Nullable<string>): void;
    setHeight(column: number): void;
    setHeightByName(columnName: Nullable<string>): void;
    setToolTip(columns: Int32Array): void;
    setToolTipByNames(columnNames: Array<Nullable<string>>): void;
    setAlgorithm(algorithm: Nullable<any>/* Nullable<Algorithm> */): void;
    setAggregation(aggregation: Nullable<any>/* Nullable<Aggregation> */): void;
    setScale(scale: Nullable<any>/* Nullable<Scale> */): void;
    setNesting(nesting: Nullable<any>/* Nullable<Nesting> */): void;
    setOrdering(ordering: Nullable<any>/* Nullable<Ordering> */): void;
    setDepth(depth: Nullable<any>/* Nullable<Depth> */): void;
    setLabeling(labeling: Nullable<any>/* Nullable<Labeling> */): void;
    setRendering(rendering: Nullable<Rendering>): void;
    setLightSourceHeight(value: number): void;
    setLightSourceAmbient(value: number): void;
    setLightSourceX(value: number): void;
    setLightSourceY(value: number): void;
    setLightSourceZ(value: number): void;
    setLabelingFont(font: Nullable<any>/* Nullable<CPFont> */): void;
    setLabelingForegroundColor(color: Nullable<any>/* Nullable<CPColor> */): void;
    setLabelingBackgroundColor(color: Nullable<any>/* Nullable<CPColor> */): void;
    setHeaderFont(font: Nullable<any>/* Nullable<CPFont> */): void;
    setHeaderForegroundColor(color: Nullable<any>/* Nullable<CPColor> */): void;
    setHeaderBackgroundColor(color: Nullable<any>/* Nullable<CPColor> */): void;
    readonly __doNotUseOrImplementIt: {
        readonly "com.treemap.TreeMap": unique symbol;
    };
}
export declare interface TreeMapColumnSettings {
    readonly properties: any/* MutableProperties<Nullable<string>> */;
    getAlgorithmProperty(): any/* MutableProperty<Nullable<Algorithm>> */;
    getAlgorithm(): any/* Algorithm */;
    setAlgorithm(algorithm: Nullable<any>/* Nullable<Algorithm> */): void;
    getAggregationProperty(): any/* MutableProperty<Nullable<Aggregation>> */;
    getAggregation(): Nullable<any>/* Nullable<Aggregation> */;
    setAggregation(aggregation: Nullable<any>/* Nullable<Aggregation> */): void;
    getScaleProperty(): any/* MutableProperty<Nullable<Scale>> */;
    getScale(): Nullable<any>/* Nullable<Scale> */;
    setScale(scale: Nullable<any>/* Nullable<Scale> */): void;
    getNestingProperty(): any/* MutableProperty<Nullable<Nesting>> */;
    getNesting(): Nullable<any>/* Nullable<Nesting> */;
    setNesting(nesting: Nullable<any>/* Nullable<Nesting> */): void;
    getOrderingProperty(): any/* MutableProperty<Nullable<Ordering>> */;
    getOrdering(): any/* Ordering */;
    setOrdering(ordering: Nullable<any>/* Nullable<Ordering> */): void;
    getOrderingDirectionProperty(): any/* MutableProperty<Nullable<Ordering.SortOrder>> */;
    getOrderingDirection(): Nullable<any>/* Nullable<Ordering.SortOrder> */;
    setOrderingDirection(ordering: Nullable<any>/* Nullable<Ordering.SortOrder> */): void;
    getOrderingVerticalVanishingPointProperty(): any/* MutableProperty<number> */;
    getOrderingVerticalVanishingPoint(): number;
    setOrderingVerticalVanishingPoint(verticalVanishingPoint: number): void;
    getOrderingHorizontalVanishingPointProperty(): any/* MutableProperty<number> */;
    getOrderingHorizontalVanishingPoint(): number;
    setOrderingHorizontalVanishingPoint(alignment: number): void;
    getLabelingProperty(): any/* MutableProperty<Nullable<Labeling>> */;
    getLabeling(): Nullable<any>/* Nullable<Labeling> */;
    setLabeling(labeling: Nullable<any>/* Nullable<Labeling> */): void;
    getLabelingFontProperty(): any/* MutableProperty<Nullable<CPFont>> */;
    getLabelingFont(): Nullable<any>/* Nullable<CPFont> */;
    setLabelingFont(font: Nullable<any>/* Nullable<CPFont> */): void;
    getLabelingForegroundProperty(): any/* MutableProperty<Nullable<CPColor>> */;
    getLabelingForeground(): Nullable<any>/* Nullable<CPColor> */;
    setLabelingForeground(color: Nullable<any>/* Nullable<CPColor> */): void;
    getLabelingEffectColorProperty(): any/* MutableProperty<Nullable<CPColor>> */;
    getLabelingEffectColor(): Nullable<any>/* Nullable<CPColor> */;
    setLabelingEffectColor(color: Nullable<any>/* Nullable<CPColor> */): void;
    getLabelingEffectProperty(): any/* MutableProperty<Nullable<EnhancedLabel.Effect>> */;
    getLabelingEffect(): Nullable<EnhancedLabel.Effect>;
    setLabelingEffect(effect: Nullable<EnhancedLabel.Effect>): void;
    getLabelingHorizontalAlignmentProperty(): any/* MutableProperty<number> */;
    getLabelingHorizontalAlignment(): number;
    setLabelingHorizontalAlignment(alignment: number): void;
    getLabelingVerticalAlignmentProperty(): any/* MutableProperty<number> */;
    getLabelingVerticalAlignment(): number;
    setLabelingVerticalAlignment(alignment: number): void;
    getLabelingRenderingProperty(): any/* MutableProperty<Nullable<EnhancedLabel.Rendering>> */;
    getLabelingRendering(): Nullable<EnhancedLabel.Rendering>;
    setLabelingRendering(rendering: Nullable<EnhancedLabel.Rendering>): void;
    getLabelingMinimumCharactersToDisplayProperty(): any/* MutableProperty<Nullable<number>> */;
    getLabelingMinimumCharactersToDisplay(): Nullable<number>;
    setLabelingMinimumCharactersToDisplay(minimumCharactersToDisplay: Nullable<number>): void;
    getLabelingEffectOpacityProperty(): any/* MutableProperty<Nullable<number>> */;
    getLabelingEffectOpacity(): Nullable<number>;
    setLabelingEffectOpacity(opacity: Nullable<number>): void;
    getLabelingShrinkTextToFitShapeProperty(): any/* MutableProperty<boolean> */;
    getLabelingShrinkTextToFitShape(): Nullable<boolean>;
    setLabelingShrinkTextToFitShape(labelingShrinkTextToFitShape: boolean): void;
    getLabelingResizeTextToFitShapeProperty(): any/* MutableProperty<boolean> */;
    getLabelingResizeTextToFitShape(): Nullable<boolean>;
    setLabelingResizeTextToFitShape(labelingResizeTextToFitShape: boolean): void;
    getLabelingFloatProperty(): any/* MutableProperty<Nullable<boolean>> */;
    getLabelingFloat(): Nullable<boolean>;
    setLabelingFloat(labelingFloat: Nullable<boolean>): void;
    getLabelingContrastEnhancementProperty(): any/* MutableProperty<Nullable<ContrastEnhancement>> */;
    getLabelingContrastEnhancement(): Nullable<any>/* Nullable<ContrastEnhancement> */;
    setLabelingContrastEnhancement(contrastEnhancement: Nullable<any>/* Nullable<ContrastEnhancement> */): void;
    getNestingAmountProperty(): any/* MutableProperty<Nullable<number>> */;
    getNestingAmount(): Nullable<number>;
    setNestingAmount(amount: Nullable<number>): void;
    getNestingBackgroundProperty(): any/* MutableProperty<Nullable<CPColor>> */;
    getNestingBackground(): Nullable<any>/* Nullable<CPColor> */;
    setNestingBackground(color: Nullable<any>/* Nullable<CPColor> */): void;
    getHeaderFontProperty(): any/* MutableProperty<Nullable<CPFont>> */;
    getHeaderFont(): Nullable<any>/* Nullable<CPFont> */;
    setHeaderFont(font: Nullable<any>/* Nullable<CPFont> */): void;
    getHeaderForegroundProperty(): any/* MutableProperty<Nullable<CPColor>> */;
    getHeaderForeground(): Nullable<any>/* Nullable<CPColor> */;
    setHeaderForeground(color: Nullable<any>/* Nullable<CPColor> */): void;
    getHeaderBackgroundProperty(): any/* MutableProperty<Nullable<CPColor>> */;
    getHeaderBackground(): Nullable<any>/* Nullable<CPColor> */;
    setHeaderBackground(color: Nullable<any>/* Nullable<CPColor> */): void;
    getHeaderEffectColorProperty(): any/* MutableProperty<Nullable<CPColor>> */;
    getHeaderEffectColor(): Nullable<any>/* Nullable<CPColor> */;
    setHeaderEffectColor(color: Nullable<any>/* Nullable<CPColor> */): void;
    getHeaderEffectProperty(): any/* MutableProperty<Nullable<EnhancedLabel.Effect>> */;
    getHeaderEffect(): Nullable<EnhancedLabel.Effect>;
    setHeaderEffect(effect: Nullable<EnhancedLabel.Effect>): void;
    getHeaderHorizontalAlignmentProperty(): any/* MutableProperty<number> */;
    getHeaderHorizontalAlignment(): number;
    setHeaderHorizontalAlignment(alignment: number): void;
    getHeaderVerticalAlignmentProperty(): any/* MutableProperty<number> */;
    getHeaderVerticalAlignment(): number;
    setHeaderVerticalAlignment(alignment: number): void;
    getHeaderRenderingProperty(): any/* MutableProperty<Nullable<EnhancedLabel.Rendering>> */;
    getHeaderRendering(): Nullable<EnhancedLabel.Rendering>;
    setHeaderRendering(rendering: Nullable<EnhancedLabel.Rendering>): void;
    getHeaderMinimumCharactersToDisplayProperty(): any/* MutableProperty<Nullable<number>> */;
    getHeaderMinimumCharactersToDisplay(): Nullable<number>;
    setHeaderMinimumCharactersToDisplay(minimumCharactersToDisplay: Nullable<number>): void;
    getHeaderEffectOpacityProperty(): any/* MutableProperty<Nullable<number>> */;
    getHeaderEffectOpacity(): Nullable<number>;
    setHeaderEffectOpacity(opacity: Nullable<number>): void;
    getHeaderInsetsProperty(): any/* MutableProperty<Nullable<Insets>> */;
    getHeaderInsets(): Nullable<any>/* Nullable<Insets> */;
    setHeaderInsets(insets: Nullable<any>/* Nullable<Insets> */): void;
    getTooltipFontProperty(): any/* MutableProperty<Nullable<CPFont>> */;
    getTooltipFont(): Nullable<any>/* Nullable<CPFont> */;
    setTooltipFont(font: Nullable<any>/* Nullable<CPFont> */): void;
    getTooltipForegroundProperty(): any/* MutableProperty<Nullable<CPColor>> */;
    getTooltipForeground(): Nullable<any>/* Nullable<CPColor> */;
    setTooltipForeground(color: Nullable<any>/* Nullable<CPColor> */): void;
    getTooltipRenderingProperty(): Nullable<any>/* Nullable<MutableProperty<Nullable<EnhancedLabel.Rendering>>> */;
    getTooltipRendering(): Nullable<EnhancedLabel.Rendering>;
    setTooltipRendering(rendering: Nullable<EnhancedLabel.Rendering>): void;
    getBorderColorProperty(): any/* MutableProperty<Nullable<CPColor>> */;
    getBorderColor(): Nullable<any>/* Nullable<CPColor> */;
    setBorderColor(color: Nullable<any>/* Nullable<CPColor> */): void;
    getBorderThicknessInterval(): Nullable<any>/* Nullable<MutableBoundedInterval> */;
    getBorderThickness(): number;
    setBorderThickness(value: number): void;
    getFormatProperty(): any/* MutableProperty<Nullable<CPFormat<Nullable<any>>>> */;
    getFormat(): Nullable<any>/* Nullable<CPFormat<Nullable<any>>> */;
    setFormat(format: Nullable<any>/* Nullable<CPFormat<Nullable<any>>> */): void;
    getShowLabelProperty(): any/* MutableProperty<boolean> */;
    getShowLabel(): boolean;
    setShowLabel(show: boolean): void;
    getColorMapProperty(): Nullable<any>/* Nullable<MutableProperty<Nullable<MutableColorMap>>> */;
    getColorMap(): Nullable<MutableColorMap>;
    setColorMap(colorMap: Nullable<MutableColorMap>): void;
    getProperty(key: Nullable<string>): Nullable<any>;
    setProperty(property: Nullable<string>, value: Nullable<any>): void;
    isDefaults(): boolean;
    isOverrideDefaults(): boolean;
    getOverrideDefaultsProperty(): Nullable<any>/* Nullable<MutableProperty<boolean>> */;
    setOverrideDefaults(overrideDefaults: boolean): void;
    getPropertyOverride(key: Nullable<string>): Nullable<any>;
    reset(): void;
    readonly __doNotUseOrImplementIt: {
        readonly "com.treemap.TreeMapColumnSettings": unique symbol;
    };
}
export declare interface TreeMapModel<N, Row, Column> extends TreeMapAccessor<N> {
    readonly dataFrame: Nullable<any>/* Nullable<DataFrame<Row, Column, UnknownType *>> */;
    readonly properties: any/* MutableProperties<Nullable<string>> */;
    readonly groupByColumns: any/* Iterable<Nullable<Column>> */;
    readonly sizeColumns: any/* Iterable<Nullable<Column>> */;
    readonly colorColumns: any/* Iterable<Nullable<Column>> */;
    readonly heightColumns: any/* Iterable<Nullable<Column>> */;
    readonly labelsColumns: any/* Iterable<Nullable<Column>> */;
    readonly tooltipColumns: any/* Iterable<Nullable<Column>> */;
    isNumericType(column: Column): boolean;
    isTemporalType(column: Column): boolean;
    isVisualType(column: Column): boolean;
    getColorMap(column: Nullable<Column>): Nullable<MutableColorMap>;
    getCategoricalColorMap(column: Column): MutableColorMap;
    getPredefinedColorMap(column: Column): MutableColorMap;
    getCustomColorMap(column: Column): MutableColorMap;
    createDefaultColorMap(column: Column): Nullable<MutableColorMap>;
    readonly maximumSize: number;
    setNestedShape(node: N, shape: Nullable<any>/* Nullable<Shape> */): void;
    getNestedShape(node: N): Nullable<any>/* Nullable<Shape> */;
    getGroupByColumn(node: N): Nullable<Column>;
    getChildrenGroupByColumn(node: N): Nullable<Column>;
    getLabelName(node: N): Nullable<string>;
    colorProvider: any/* ColorProvider<N> */;
    setColor(node: N, color: Nullable<any>/* Nullable<CPColor> */): void;
    getColor(node: N): Nullable<any>/* Nullable<CPColor> */;
    isLeaf(node: N): boolean;
    getParent(node: N): Nullable<N>;
    isRoot(node: N): boolean;
    getChildren(parent: N): any/* Iterable<N> */;
    getChildrenOfTypeParent(parent: N): any/* Iterable<N> */;
    getChildCount(node: N): number;
    getCushionImage(node: N): Nullable<any>/* Nullable<CPImage> */;
    getCushionColor(node: N): Nullable<any>/* Nullable<CPColor> */;
    parentPreorderEnumeration(parent: N): any/* Iterable<N> */;
    preorderEnumeration(parent: N): any/* Iterable<N> */;
    breadthFirstIterator(parent: N): any/* Iterable<N> */;
    depthFirstIterator(parent: N): any/* Iterable<N> */;
    getNodeForRow(row: Row): N;
    getTreeMapColumn(columnIndex: number): Nullable<Column>;
    getTreeMapColumnByName(columnName: Nullable<string>): Nullable<Column>;
    getTreeMapColumnsInclude(includeNone: boolean): any/* Iterable<Nullable<Column>> */;
    getTreeMapColumnsByIndices(columns: Int32Array): KtList<Column>;
    getTreeMapColumns(columns: Array<Column>): KtList<Column>;
    getTreeMapColumnsByNames(columnNames: Array<Nullable<string>>): KtList<Column>;
    getNumericMax(columnIndex: Nullable<Column>): Nullable<number>;
    getNumericMin(columnIndex: Nullable<Column>): Nullable<number>;
    setNumericMax(columnIndex: Nullable<Column>, max: number): void;
    setNumericMin(columnIndex: Nullable<Column>, min: number): void;
    readonly normalizedLightSourceX: number;
    readonly normalizedLightSourceY: number;
    readonly normalizedLightSourceZ: number;
    readonly rowCount: number;
    readonly columnCount: number;
    columns(): Nullable<any>/* Nullable<Iterable<Column>> */;
    getColumnName(columnIndex: Column): Nullable<string>;
    getColumnClass(columnIndex: Column): Nullable<any>/* Nullable<KClass<UnknownType *>> */;
    getValueAt(node: N, columnIndex: Column): Nullable<any>;
    isEveryValueUnique(column: Nullable<Column>): boolean;
    getAggregateValue(node: N, column: Nullable<Column>): Nullable<any>;
    getStringValue(node: N, column: Column): Nullable<string>;
    readonly root: Nullable<N>;
    currentRoot: Nullable<N>;
    readonly probing: any/* MutableSingleSelection<Nullable<N>> */;
    readonly highlighting: any/* MutableSelection<N> */;
    readonly selection: any/* MutableSelection<N> */;
    readonly filter: any/* MutableFilter<N> */;
    readonly search: any/* MutableFilter<N> */;
    readonly settings: TreeMapSettings<Column>;
    readonly worker: Nullable<any>/* Nullable<TreeMapWorker> */;
    readonly workerFuture: Nullable<any>/* Nullable<Future<UnknownType *>> */;
    addListener(treeMapListener: any/* TreeMapListener */): void;
    removeListener(treeMapListener: any/* TreeMapListener */): void;
    getNode(position: Nullable<any>/* Nullable<Point> */): Nullable<N>;
    readonly isDirty: boolean;
    waitUntilReady(): void;
    getSumSize(node: N): number;
    progressProperty(): any/* MutableProperty<number> */;
    getFormatPattern(columnIndex: number): Nullable<string>;
    setFormatPattern(columnIndex: number, pattern: Nullable<string>): void;
    readonly colorFactory: any/* MkColorFactory */;
    readonly __doNotUseOrImplementIt: {
        readonly "com.treemap.TreeMapModel": unique symbol;
    };
}
export declare interface TreeMapSettings<Column> {
    readonly properties: any/* MutableProperties<Nullable<string>> */;
    getDimensionFixed(): Nullable<boolean>;
    setDimensionFixed(fixed: Nullable<boolean>): void;
    getDimension(): Nullable<any>/* Nullable<Dimension> */;
    setDimension(dimension: Nullable<any>/* Nullable<Dimension> */): void;
    getProgressive(): Nullable<any>/* Nullable<Progressive> */;
    setProgressive(progressive: Nullable<any>/* Nullable<Progressive> */): void;
    groupByColumns: KtList<Column>;
    sizeColumn: Nullable<Column>;
    colorColumn: Nullable<Column>;
    labelsColumns: KtList<Column>;
    toolTipColumns: KtList<Column>;
    backgroundColumn: Nullable<Column>;
    heightColumn: Nullable<Column>;
    isHideFilterResults(): Nullable<boolean>;
    setHideFilterResults(hideFilterResults: Nullable<boolean>): void;
    isHideSearchResults(): Nullable<boolean>;
    setHideSearchResults(hideSearchResults: Nullable<boolean>): void;
    getMaximumHeight(): number;
    setMaximumHeight(height: number): void;
    setGroupBy(columns: Int32Array): void;
    setGroupByByNames(columnNames: Array<Nullable<string>>): void;
    setLabels(columns: Int32Array): void;
    setLabelsByNames(columnNames: Array<Nullable<string>>): void;
    setToolTip(columns: Int32Array): void;
    setToolTipByNames(columnNames: Array<Nullable<string>>): void;
    setBackground(column: number): void;
    setBackgroundByName(columnName: Nullable<string>): void;
    setSize(column: number): void;
    setSizeByName(columnName: Nullable<string>): void;
    setColor(column: number): void;
    setColorByName(columnName: Nullable<string>): void;
    setHeight(column: number): void;
    setHeightByName(columnName: Nullable<string>): void;
    getDepth(): Nullable<any>/* Nullable<Depth> */;
    setDepth(depth: Nullable<any>/* Nullable<Depth> */): void;
    rendering: Nullable<Rendering>;
    getLightSourceHeight(): number;
    setLightSourceHeight(value: number): void;
    getLightSourceAmbient(): number;
    setLightSourceAmbient(value: number): void;
    getLightSourceX(): number;
    setLightSourceX(value: number): void;
    getLightSourceY(): number;
    setLightSourceY(value: number): void;
    getLightSourceZ(): number;
    setLightSourceZ(value: number): void;
    getBackgroundProperty(): any/* MutableProperty<Nullable<CPColor>> */;
    getBackground(): Nullable<any>/* Nullable<CPColor> */;
    setBackgroundColor(color: Nullable<any>/* Nullable<CPColor> */): void;
    getTooltipBackgroundProperty(): any/* MutableProperty<Nullable<CPColor>> */;
    getTooltipBackground(): Nullable<any>/* Nullable<CPColor> */;
    setTooltipBackground(color: Nullable<any>/* Nullable<CPColor> */): void;
    getProbingColorProperty(): any/* MutableProperty<Nullable<CPColor>> */;
    getProbingColor(): Nullable<any>/* Nullable<CPColor> */;
    setProbingColor(color: Nullable<any>/* Nullable<CPColor> */): void;
    getSelectionColorProperty(): any/* MutableProperty<Nullable<CPColor>> */;
    getSelectionColor(): Nullable<any>/* Nullable<CPColor> */;
    setSelectionColor(color: Nullable<any>/* Nullable<CPColor> */): void;
    getShowPopup(field: Nullable<Column>): boolean;
    setShowPopup(field: Nullable<Column>, show: boolean): void;
    getValue(key: Nullable<string>): Nullable<any>;
    addTreeMapSettingsListener(listener: any/* TreeMapSettingsListener */): void;
    removeTreeMapSettingsListener(listener: any/* TreeMapSettingsListener */): void;
    removeTreeMapSettingsListeners(): void;
    getGroupByColumnsSelection(): any/* MutableSelection<Column> */;
    getSizeColumnSelection(): any/* MutableSingleSelection<Nullable<Column>> */;
    getColorColumnSelection(): any/* MutableSingleSelection<Nullable<Column>> */;
    getLabelColumnsSelection(): any/* MutableSelection<Column> */;
    getTooltipColumnsSelection(): any/* MutableSelection<Column> */;
    getBackgroundColumnSelection(): any/* MutableSingleSelection<Nullable<Column>> */;
    getHeightColumnSelection(): any/* MutableSingleSelection<Nullable<Column>> */;
    getDepthSelection(): any/* MutableSingleSelection<Nullable<Depth>> */;
    readonly renderingSelection: any/* MutableSingleSelection<Nullable<Rendering>> */;
    getProgressiveSelection(): any/* MutableSingleSelection<Nullable<Progressive>> */;
    getHideFilterResultsSelection(): any/* MutableProperty<Nullable<boolean>> */;
    getHideSearchResultsSelection(): any/* MutableProperty<Nullable<boolean>> */;
    getDefaultColumnSettings(): TreeMapColumnSettings;
    getColumnSettings(field: Nullable<Column>): TreeMapColumnSettings;
    readonly maximumHeightInterval: any/* MutableBoundedInterval */;
    readonly lightSourceHeightInterval: any/* MutableBoundedInterval */;
    readonly lightSourceAmbientInterval: any/* MutableBoundedInterval */;
    readonly lightSourceXInterval: any/* MutableBoundedInterval */;
    readonly lightSourceYInterval: any/* MutableBoundedInterval */;
    readonly lightSourceZInterval: any/* MutableBoundedInterval */;
    resetToDefaults(): void;
    save(dataFrame: any/* DataFrame<Nullable<any>, Column, Nullable<any>> */, elementFactory: any/* ElementFactory */, root: any/* Element */): void;
    readonly __doNotUseOrImplementIt: {
        readonly "com.treemap.TreeMapSettings": unique symbol;
    };
}
export declare class JsTreeMap /* extends DefaultTreeMap<number, string> */ implements TreeMap<any/* AbstractTreeMapNode<number, string> */, number, string> {
    constructor(elementId: string, model: Nullable<DefaultTreeMapModel<number, string>>);
    get component(): any/* CPComponent */;
    get view(): Nullable<any>/* Nullable<TreeMapView<AbstractTreeMapNode<number, string>, number, string>> */;
    set view(value: Nullable<any>/* Nullable<TreeMapView<AbstractTreeMapNode<number, string>, number, string>> */);
    get controller(): Nullable<any>/* Nullable<TreeMapController<AbstractTreeMapNode<number, string>, number, string>> */;
    set controller(value: Nullable<any>/* Nullable<TreeMapController<AbstractTreeMapNode<number, string>, number, string>> */);
    get model(): Nullable<TreeMapModel<any/* AbstractTreeMapNode<number, string> */, number, string>>;
    set model(value: Nullable<TreeMapModel<any/* AbstractTreeMapNode<number, string> */, number, string>>);
    setGroupBy(columns: Int32Array): void;
    setGroupByByNames(columnNames: Array<Nullable<string>>): void;
    setLabels(columns: Int32Array): void;
    setLabelsByNames(columnNames: Array<Nullable<string>>): void;
    setBackground(column: number): void;
    setBackgroundByName(columnName: Nullable<string>): void;
    setSize(column: number): void;
    setSizeByName(columnName: Nullable<string>): void;
    setColor(column: number): void;
    setColorByName(columnName: Nullable<string>): void;
    setHeight(column: number): void;
    setHeightByName(columnName: Nullable<string>): void;
    setToolTip(columns: Int32Array): void;
    setToolTipByNames(columnNames: Array<Nullable<string>>): void;
    setAlgorithm(algorithm: Nullable<any>/* Nullable<Algorithm> */): void;
    setAggregation(aggregation: Nullable<any>/* Nullable<Aggregation> */): void;
    setScale(scale: Nullable<any>/* Nullable<Scale> */): void;
    setNesting(nesting: Nullable<any>/* Nullable<Nesting> */): void;
    setOrdering(ordering: Nullable<any>/* Nullable<Ordering> */): void;
    setDepth(depth: Nullable<any>/* Nullable<Depth> */): void;
    setLabeling(labeling: Nullable<any>/* Nullable<Labeling> */): void;
    setRendering(rendering: Nullable<Rendering>): void;
    setLightSourceHeight(value: number): void;
    setLightSourceAmbient(value: number): void;
    setLightSourceX(value: number): void;
    setLightSourceY(value: number): void;
    setLightSourceZ(value: number): void;
    setLabelingFont(font: Nullable<any>/* Nullable<CPFont> */): void;
    setLabelingForegroundColor(color: Nullable<any>/* Nullable<CPColor> */): void;
    setLabelingBackgroundColor(color: Nullable<any>/* Nullable<CPColor> */): void;
    setHeaderFont(font: Nullable<any>/* Nullable<CPFont> */): void;
    setHeaderForegroundColor(color: Nullable<any>/* Nullable<CPColor> */): void;
    setHeaderBackgroundColor(color: Nullable<any>/* Nullable<CPColor> */): void;
    readonly __doNotUseOrImplementIt: TreeMap<any/* AbstractTreeMapNode<number, string> */, number, string>["__doNotUseOrImplementIt"];
}
export declare interface TreeMapProps extends Props {
    model?: Nullable<DefaultTreeMapModel<number, string>>;
}
export declare const TreeMapComponent: { get(): ComponentType<TreeMapProps>; };
export declare function getTreeMapComponent(): any;